#ifndef CIAO_CANONICAL_H
#define CIAO_CANONICAL_H

#include "macros.h"

#ifdef cfCIAO_CANONICAL_IMPL_HW
# define cfCIAO_CANONICAL_IMPL hw::hal::Canonical
# define cfCIAO_CANONICAL_IMPL_HEADER "hw/hal/Canonical.h"
#else
# define cfCIAO_CANONICAL_IMPL os::dev::std::Canonical
# define cfCIAO_CANONICAL_IMPL_HEADER "os/dev/std/Canonical.h"
#endif

#ifndef cfCIAO_DECOUPLE
# include cfCIAO_CANONICAL_IMPL_HEADER
#endif

namespace ciao { namespace dev { namespace std {

class CIAO_CLASS( Canonical, cfCIAO_CANONICAL_IMPL) {
	CIAO_CLASS_BODY( Canonical, cfCIAO_CANONICAL_IMPL );
public:
// methods defined by both, os::dev::std::Canonical 
// and hw::hal::Canonical
	void operation_A( int );
	
// additional methods, only defined by os::dev::std::Canonical 
#ifndef cfCIAO_CANONICAL_IMPL_HW
	int operation_B();
#endif

};

}}}	// namespace ciao::dev::std

#ifdef cfCIAO_INLINE				// if ciao-layer shall be inlined
# include "Canonical.inl"	// include implementation here
#endif
#endif // CIAO_CANONICAL_H