$VAR1 = {
  'vname' => 'x86',
  'name' => 'ciao_platform',
  'dir' => 'src',
  'comp' => [
    {
      'vname' => 'hw',
      'name' => 'ciao_platform_hw',
      'subdir' => 'hw',
      'comp' => [
        {
          'vname' => 'hal',
          'name' => 'ciao_platform_hw_hal',
          'subdir' => 'hal',
          'comp' => [
            {
              'vname' => 'arch',
              'name' => 'ciao_platform_hw_hal_arch',
              'subdir' => '!ARCH',
              'comp' => [
                {
                  'vname' => 'CPU',
                  'name' => 'hal_CPU_class',
                  'classname' => 'hw::hal::CPU',
                  'comp' => [
                    {
                      'depends' => '&platform_native',
                      'file' => 'CPU.h'
                    },
                    {
                      'depends' => '&platform_guest',
                      'srcfile' => 'CPU-guest.h',
                      'file' => 'CPU.h'
                    },
                    {
                      'file' => 'CPU.cpp'
                    }
                  ]
                },
                {
                  'vname' => 'TCBBasic',
                  'name' => 'hal_TCBBasic_class',
                  'classname' => 'hw::hal::TCBBasic',
                  'comp' => [
                    {
                      'files' => [
                        'TCBBasic.h',
                        'TCBBasic.cpp'
                      ]
                    },
                    {
                      'vname' => 'chain() operation, speed-optimized',
                      'name' => 'ciao_platform_hw_hal_threading_fastchain',
                      'depends' => '&hal_threading_tcbbasic_chain_fast',
                      'comp' => [
                        {
                          'files' => [
                            'TCBBasic_Chain.ah'
                          ]
                        }
                      ]
                    }
                  ]
                },
                {
                  'vname' => 'hw::hal::TCBUser',
                  'name' => 'hal_TCBUser_class',
                  'classname' => 'hw::hal::TCBUser',
                  'comp' => [
                    {
                      'files' => [
                        'TCBUser.h',
                        'TCBUser.cpp'
                      ]
                    },
                    {
                      'vname' => 'automatic context cleanup on termination for TCBUser',
                      'name' => 'ciao_platform_hw_hal_threading_tcbuser_cleanup',
		              'depends' => '&hal_threading_tcbuser_cleanup',
                      'comp' => [
                        {
                          'files' => [
                            'TCBUser_Cleanup.ah',
                            'TCBUser_CleanupSupport.ah'
                          ]
                        }
                      ]
                    }
                  ]
                },
                {
                  'vname' => 'MPU',
                  'name' => 'hal_MPU_class',
                  'classname' => 'hw::hal::SysData',
                  'comp' => [
                    {
                      'files' => [
                        'MPU.h'
                      ]
                    }
                  ]
                },
                {
                  'vname' => 'Native Platform Configuration',
                  'name' => 'ciao_native_platform_configuration',
                  'depends' => '&platform_native',
                  'file' => 'platform.h'
                },
                {
                  'vname' => 'Guest Platform Configuration',
                  'name' => 'ciao_guest_platform_configuration',
                  'depends' => '&platform_guest',
                  'file' => 'platform.h',
                  'srcfile' => 'platform-guest.h'
                },
                {
                  'name' => 'KernelLock',
                  'depends' => '&hal_kernellockimplementation',
                  'comp' => [
                    {
                      'files' => [
                        'KernelLock.ah'
                      ]
                    }
                  ]
                },
                {
                  'vname' => 'Paging',
                  'name' => 'ciao_hw_hal_paging',
                  'depends' => '&hal_paging',
                  'comp' => [
                    {
                      'files' => [
                        'Paging.h',
                        'Paging.cpp',
                        'Paging_init.ah',
                        'BasicPageTable.h',
                        'BasicPageTableMempool.h'
                      ]
                    },
                    {
                      'depends' => '&hal_paging_debugging',
                      'file' => 'Paging_debug.ah'
                    },
                    {
                      'depends' => '&hal_paging_format_32 or &hal_paging_format_pae',
                      'file' => 'PagingAsm.asm'
                    },
                    {
                      'depends' => '&hal_paging_format_lm',
                      'file' => 'PagingAsm64.asm'
                    },
                    {
                      'depends' => '&hal_paging_format_pae',
                      'file' => 'PAEAsm.asm'
                    },
                    {
                      'vname' => 'Pagetable (32-Bit)',
                      'depends' => '&hal_paging_format_32',
                      'file' => 'PageTable.h',
                      'srcfile' => 'PageTable32.h'
                    },
                    {
                      'vname' => 'Pagetable (64-Bit)',
                      'depends' => '&hal_paging_format_lm or &hal_paging_format_pae',
                      'file' => 'PageTable.h',
                      'srcfile' => 'PageTable64.h'
                    },
                    {
                      'depends' => '&hal_paging_format_32',
                      'files' => [
                        'BasicPageTable32.ah',
                        'BasicPageTable32_slice.ah'
                      ]
                    },
                    {
                      'depends' => '&hal_paging_format_pae',
                      'files' => [
                        'BasicPageTablePAE.ah',
                        'BasicPageTablePAE_slice.ah'
                      ]
                    },
                    {
                      'depends' => '&hal_paging_format_lm',
                      'files' => [
                        'BasicPageTable64.ah',
                        'BasicPageTable64_slice.ah'
                      ]
                    },
                    {
                      'depends' => '&hal_paging_format_32 or &hal_paging_format_pae',
                      'file' => 'Paging.ah'
                    },
                    {
                      'depends' => '&hal_paging_format_pae',
                      'file' => 'PagingPAE.ah'
                    }
                  ]
                },
                {
                  'vname' => 'Conventional Continuation',
                  'depends' =>  '&hal_contextswitch_conventional',
                  'comp' => [
                    {
                      'vname' => 'Continuation (32-Bit)',
                      'depends' => '&architecture_ia32',
                      'files' => [
                        'Continuation.h',
                        'Continuation.cpp',
                        'x86Context.h',
                        'ContinuationAsm.asm'
                      ]
                    },
                    {
                      'vname' => 'Continuation (64-Bit)',
                      'depends' => '&architecture_x86_64',
                      'comp' => [
                        {
                          'file' => 'Continuation.h',
                          'srcfile' => 'Continuation64.h'
                        },
                        {
                          'file' => 'Continuation.cpp',
                          'srcfile' => 'Continuation64.cpp'
                        },
                        {
                          'file' => 'x86Context.h',
                          'srcfile' => 'x86_64Context.h'
                        },
                        {
                          'file' => 'ContinuationAsm.asm',
                          'srcfile' => 'ContinuationAsm64.asm'
                        }
                      ]
                    },
                    {
                      'depends' => '&hal_protection_memory_protection_page_based',
                      'file' => 'x86Context_cr3.ah',
                      'comp' => [
                        {
                          'depends' => '&architecture_ia32',
                          'file' => 'x86Context_cr3_slice.ah'
                        },
                        {
                          'depends' => '&architecture_x86_64',
                          'file' => 'x86Context_cr3_slice.ah',
                          'srcfile' => 'x86_64Context_cr3_slice.ah'
                        }
                      ]
                    }
                  ]
                },
                {
                  'vname' => 'TSS Continuation',
                  'depends' =>  '&hal_contextswitch_tss',
                  'comp' => [
                    {
                      'file' => 'Continuation.h',
                      'srcfile' => 'ContinuationTSS.h'
                    },
                    {
                      'file' => 'Continuation.cpp',
                      'srcfile' => 'ContinuationTSS.cpp'
                    },
                    {
                      'file' => 'x86Context.h',
                      'srcfile' => 'x86_TSSContext.h'
                    },
                    {
                      'depends' => 'not &hal_protection_memory_protection_page_based',
                      'file' => 'x86_TSSContext_flags.h'
                    },
                    {
                      'depends' => '&hal_protection_memory_protection_page_based',
                      'file' => 'x86_TSSContext_flags.h',
                      'srcfile' => 'x86_TSSContext_flags_paging.h'
                    }
                  ]
                },
                {
                  'vname' => 'FPU Continuation',
                  'depends' =>  '&hal_contextswitch_fpu',
                  'comp' => [
                    {
                      'files' => [
                         'x87Context.ah',
                         'x87Context_slice.ah'
                       ]
                    },
                    {
                      'depends' =>  '&hal_contextswitch_tss',
                      'file' => 'x87ContextTSS.ah'
                    }
                  ]
                },
                {
                  'vname' => 'paged based memory protection',
                  'name' => 'ciao_platform_hw_hal_arch_memory_protection',
                  'depends' =>  '&hal_protection_memory_protection_page_based',
                  'files' => [
                    'Continuation_paging.ah',
                    'MemoryProtection_paging.ah',
                    'PagingTask.ah',
                    'PagingTask_slice.ah'
                  ]
                },
                {
                  'vname' => 'SystemClockImpl',
                  'name' => 'hal_SystemClockImpl_class',
                  'depends' =>  '&hal_systemclock',
                  'file' => 'SystemClockImpl.h'
                },
                {
                  'vname' => 'PIT-based SystemTimerImpl',
                  'name' => 'hal_PITSystemTimerImpl_class',
                  'depends' =>  '&hal_systemtimer_pit',
                  'comp' => [
                    {
                      'file' => 'SystemTimerImpl.h',
                      'srcfile' => 'PITSystemTimerImpl.h'
                    },
                    {
                      'file' => 'SystemTimerImpl.cpp',
                      'srcfile' => 'PITSystemTimerImpl.cpp'
                    },
                    {
                      'file' => 'SystemTimerImpl.ah',
                      'srcfile' => 'PITSystemTimerImpl.ah'
                    }
                  ]
                }
              ]
            },
#################### HAL DEVICES ... ############
            {
              'vname' => 'AST0',
              'name' => 'hal_ast0',
              'depends' => '&hal_ast0',
              'comp' => [
                {
                  'vname' => 'hw::hal::AST0',
                  'name' => 'hal_ast0_class',
                  'classname' => 'hw::hal::AST0',
                  'comp' => [
                    {
                      'files' => [
                        'AST0.h',
                        'AST0.cpp',
                        'AST0_Init.ah'
                      ]
                    }
                  ]
                },
                {
                  'name' => 'hal_astimpl_cpu_src0',
                  'depends' => '&hal_astimpl_cpu_src0',
                  'comp' => [
                    {
                      'vname' => 'hw::hal::ASTImpl_CPU_SRC0',
                      'name' => 'hal_astimpl_cpu_src0_class',
                      'classname' => 'hw::hal::ASTImpl_CPU_SRC0',
                      'comp' => [
                        {
                          'files' => [
                            'ASTImpl_CPU_SRC0.h',
                            'ASTImpl_CPU_SRC0.cpp',
                            'ASTImpl_CPU_SRC0_IRQBinding.ah',
                            'ASTImpl_CPU_SRC0_OSBinding.ah' #TODO: depends ISR2-Support? (don't think so)
                          ]
                        }
                      ]
                    },
                    {
                      'vname' => 'AST0Impl',
                      'name' => 'hal_AST0Impl_alias',
                      'comp' => [
                        {
                          'generate' => 'alias({classname=>"::hw::hal::ASTImpl_CPU_SRC0",path=>"src/hw/hal/ASTImpl_CPU_SRC0.h",newname=>"AST0Impl",nsl=>["hw","hal"],guard=>"__pv_guard_imUNr1JotDW5Um5gv_ij_F1o0_CsQuPLDc8"});',
                          'file' => 'AST0Impl.h'
                        }
                      ]
                    }
                  ]
                }
              ]
            },
            {
              'name' => 'hal_outputdevice',
              'depends' => '&hal_outputdevice',
              'comp' => [
                {
                  'name' => 'hal_outputdevice_cga',
                  'depends' => '&hal_outputdevice_cga',
                  'classname' => 'hw::hal::OutputDeviceCGA',
                  'comp' => [
                    {
                      'files' => [
                        'OutputDeviceCGA.h',
                        'OutputDeviceCGA.cpp',
                        'OutputDeviceCGA_init.ah'
                      ]
                    },
                    {
                      'generate' => 'alias({classname=>"::hw::hal::OutputDeviceCGA",path=>"src/hw/hal/OutputDeviceCGA.h",newname=>"OutputDevice",nsl=>["hw","hal"],guard=>"__pv_guard_imUNrjhdasfhas64h43jhwasfhsadf6"});',
                      'file' => 'OutputDevice.h'
                    }
                  ]
                },
                {
                  'name' => 'hal_outputdevice_stdout',
                  'depends' => '&hal_outputdevice_stdout',
                  'classname' => 'hw::hal::OutputDeviceSTDOUT',
                  'comp' => [
                    {
                      'files' => [
                        'OutputDeviceSTDOUT.h',
                        'OutputDeviceSTDOUT.cpp',
                        'OutputDeviceSTDOUT_init.ah'
                      ]
                    },
                    {
                      'generate' => 'alias({classname=>"::hw::hal::OutputDeviceSTDOUT",path=>"src/hw/hal/OutputDeviceSTDOUT.h",newname=>"OutputDevice",nsl=>["hw","hal"],guard=>"__pv_guard_imUNrjhdasfhas6jfd6ds6fsdadf6"});',
                      'file' => 'OutputDevice.h'
                    }
                  ]
                }
              ]
            },
            {
              'vname' => 'OutputDeviceStream',
              'name' => 'hal_outputdevice_stream',
              'depends' => '&hal_outputdevice_stream',
              'comp' => [
                {
                  'files' => [
                    'OutputDeviceStream.h',
                    'OutputDeviceStream.cpp',
                    'OutputDeviceStream_init.ah'
                   ]
                },
                {
                  'depends' => '&hal_inputdevice_stream_sync',
                    'file' => 'OutputDeviceStream_sync.ah'
                }
              ]
            },
            {
              'name' => 'hal_inputdevice',
              'depends' => '&hal_inputdevice',
              'comp' => [
                {
                  'name' => 'hal_inputdevice_keyboard',
                  'depends' => '&hal_inputdevice_keyboard',
                  'classname' => 'hw::hal::InputDeviceKeyboard',
                  'comp' => [
                    {
                      'files' => [
                        'InputDeviceKeyboard.h',
                        'InputDeviceKeyboard.cpp',
                        'InputDeviceKeyboard.ah'
                      ]
                    },
                    {
                      'generate' => 'alias({classname=>"::hw::hal::InputDeviceKeyboard",path=>"src/hw/hal/InputDeviceKeyboard.h",newname=>"InputDevice",nsl=>["hw","hal"],guard=>"__pv_guard_imUNrjhda999fgjfd43jhwasfhsadf6"});',
                      'file' => 'InputDevice.h'
                    }
                  ]
                },
                {
                  'name' => 'hal_inputdevice_stdin',
                  'depends' => '&hal_inputdevice_stdin',
                  'classname' => 'hw::hal::InputDeviceSTDIN',
                  'comp' => [
                    {
                      'files' => [
                        'InputDeviceSTDIN.h',
                        'InputDeviceSTDIN.cpp',
                        'InputDeviceSTDIN.ah'
                      ]
                    },
                    {
                      'generate' => 'alias({classname=>"::hw::hal::InputDeviceSTDIN",path=>"src/hw/hal/InputDeviceSTDIN.h",newname=>"InputDevice",nsl=>["hw","hal"],guard=>"__pv_guard_iIFSuhda3sdfdasfhas6jfd6ds6fsdadf6"});',
                      'file' => 'InputDevice.h'
                    }
                  ]
                }
              ]
            },
            {
              'vname' => 'InputDeviceStream',
              'name' => 'hal_inputdevice_stream',
              'depends' => '&hal_inputdevice_stream',
              'comp' => [
                {
                  'files' => [
                    'InputDeviceStream.h',
                    'InputDeviceStream.cpp',
                    'InputDeviceStream_init.ah'
                   ]
                }
              ]
            },
            {
              'vname' => 'Network Device Support',
              'name' => 'ciao_platform_hw_hal_devices_networking',
              'depends' => '&hal_networking',
              'comp' => [
                {
                  'file' => 'NetworkDevice.h'
                },
                {
                  'depends' => '&hal_networking_multi',
                  'files' => [
                    'NetworkDevice_Multi.ah',
                    'NetworkDevice_Multi_Slice.ah'
                  ]
                },
                {
                  'depends' => '&hal_networking_single',
                  'files' => [
                    'NetworkDevice_Single.ah',
                    'NetworkDevice_Single_Slice.ah',
                    'NetworkDevice.ah'
                  ]
                },
                {
                  'vname' => 'Intel e1000 networking',
                  'name' => 'ciao_platform_hw_hal_devices_networking_e1000',
                  'comp' => [
                    {
                      'depends' => '&hal_networking_single_e1000',
                      'file' => 'NetworkDevice_Single_E1000.ah'
                    },
                    {
                      'depends' => '&hal_networking_e1000_ast0binding',
                      'file' => 'NetworkDevice_AST0_Binding_E1000.ah'
                    }
                  ]
                }
                #TODO: VirtIO
              ]
            },
            {
              'vname' => 'SystemClock',
              'name' => 'hal_SystemClock',
              'depends' => '&hal_systemclock',
              'files' => [
                'SystemClock.h',
                'SystemClock.cpp',
                'SystemClock_Inst.ah'
              ]
            },
            {
              'vname' => 'SystemTimer',
              'name' => 'ciao_platform_hw_hal_devices_systemtimer',
              'depends' => '&hal_systemtimer',
              'file' => 'SystemTimer.h'
            },
##################### HAL DEBUG ######################
            {
              'vname' => 'DebugPort support',
              'name' => 'ciao_platform_hw_hal_debugging_stdout',
              'depends' => '&hal_debugging',
              'classname' => 'hw::hal::DebugPort',
              'comp' => [
                {
                  'files' => [
                    'DebugPort.h',
                    'DebugPort.cpp',
                    'DebugPort_Inst.ah'
                  ]
                },
                {
                  'depends' => '&hal_debugport_dev_cga',
                  'generate' => 'alias({classname=>"::hw::dev::CGA_DebugPortAdapter",path=>"src/hw/dev/CGA_DebugPort_Adapter.h",newname=>"DebugPortImpl",nsl=>["hw","hal"],guard=>"__pv_guard_8787979834hjhksfdgjkd7436fsdadf6"});',
                  'file' => 'DebugPortImpl.h'
                },
                {
                  'depends' => '&hal_debugport_dev_com',
                  'generate' => 'alias({classname=>"::hw::dev::COM_DebugPortAdapter",path=>"src/hw/dev/COM_DebugPort_Adapter.h",newname=>"DebugPortImpl",nsl=>["hw","hal"],guard=>"__pv_guard_8787979834hjhksfdgjkd7436fsdadf6"});',
                  'file' => 'DebugPortImpl.h'
                },
                {
                  'depends' => '&hal_debugport_guest_stderr',
                  'generate' => 'alias({classname=>"::hw::guest::STDERR_DebugPortAdapter",path=>"src/hw/guest/STDERR_DebugPort_Adapter.h",newname=>"DebugPortImpl",nsl=>["hw","hal"],guard=>"__pv_guard_8787979834hjhksfdgjkd7436fsdadf6"});',
                  'file' => 'DebugPortImpl.h'
                },
              ]
            },
            {
              'vname' => 'ASSERT macro support',
              'name' => 'assert_handler',
              'comp' => [
                {
                  'depends' => '&lib_libcmini and &hal_debugging',
                  'file' => 'ciao_assertion_handler_printf.cpp'
                },
                {
                  'depends' => 'not &lib_libcmini or not &hal_debugging',
                  'file' => 'ciao_assertion_handler_simple.cpp' #TODO: this file seems to have deprecated includes!
                }
              ]
            },
            {
              'vname' => 'init()-Support',
              'name' => 'ciao_platform_hw_hal_init',
              'comp' => [
                {
                  'vname' => 'hw::hal::init',
                  'name' => 'ciao_platform_hw_hal_init_func',
                  'comp' => [
                    {
                      'files' => [
                        'init.h',
                        'init.cpp'
                      ]
                    }
                  ]
                }
              ]
            },
#######################################################
          ]
        },
        {
          'vname' => 'init()-Support',
          'name' => 'ciao_platform_hw_hal_init',
          'comp' => [
           {
             'vname' => 'hw::hal::init',
             'name' => 'ciao_platform_hw_hal_init_func',
             'comp' => [
               {
                 'files' => [
                   'init.h',
                   'init.cpp'
                 ]
               }
             ]
           }
         ]
       },
######################### DEV/IRQ ##############################
        {
          'vname' => 'dev/irq',
          'name' => 'ciao_platform_hw_dev',
          'subdir' => 'dev',
          'comp' => [
            {
              'vname' => 'IRQ - freestanding IRQ handler and general IRQ support',
              'name' => 'ciao_platform_hw_dev_arch_irq',
              'subdir' => '/../irq',
              'comp' => [
                {
                  'vname' => 'IRQBase',
                  'name' => 'ciao_platform_hw_irq_IRQBase',
                  'classname' => 'hw::hal::IRQBase',
                  'comp' => [
                    {
                      'depends' => '&platform_native',
                      'file' => 'IRQBase.h'
                    },
                    {
                      'depends' => '&platform_guest',
                      'file' => 'IRQBase.h',
                      'srcfile' => 'IRQBase-guest.h'
                    },
                    {
                      'file' => 'IRQBase.cpp'
                    }
                  ]
                }
              ]
            },
            {
              'vname' => 'IDE',
              'name' => 'ciao_platform_hw_dev_ide',
              'depends' => '&dev_ide',
              'comp' => [
                {
                  'files' => [
                    'IDE.h',
                    'IDE.cpp',
                    'IDE_init.ah'
                  ]
                },
                {
                  'dir' => 'src/hw/irq',
                  'files' => [
                    'IRQ_IDE1.h',
                    'IRQ_IDE1.cpp'
                  ]
                },
                {
                  'depends' => '&dev_ide_addressing_chs',
                  'files' => [
                    'IDE_CHS.ah',
                    'IDE_CHS_slice.ah'
                  ]
                },
                {
                  'depends' => '&dev_ide_addressing_lba28',
                  'files' => [
                    'IDE_LBA28.ah',
                    'IDE_LBA28_slice.ah'
                  ]
                },
                {
                  'depends' => '&dev_ide_addressing_lba48',
                  'files' => [
                    'IDE_LBA48.ah',
                    'IDE_LBA48_slice.ah'
                  ]
                },
                {
                  'depends' => '&dev_ide_dma',
                  'files' => [
                    'IDE_DMA.ah',
                    'IDE_DMA_slice.ah'
                  ]
                }
              ]
            },
            {
              'vname' => 'IOPort',
              'name' => 'ciao_platform_hw_dev_ioport',
              'depends' => '&dev_ioports',
              'file' => 'IOPort.h'
            },
            {
              'vname' => 'CGA',
              'name' => 'ciao_platform_hw_dev_cga',
              'depends' => '&dev_cga',
              'comp' => [
                {
                  'files' => [
                    'CGA.h',
                    'CGA.cpp',
                    'CGA_init.ah'
                  ]
                }
              ]
            },
            {
              'vname' => 'CGA_DebugPortAdapter',
              'name' => 'ciao_platform_hw_dev_cga_debugport_adapter',
              'depends' => '&hal_debugport_dev_cga',
              'file' => 'CGA_DebugPort_Adapter.h'
            },
            {
              'vname' => 'PIC',
              'name' => 'ciao_platform_hw_dev_pic',
              'depends' => '&dev_pic',
              'files' => [
                'PIC.h',
                'PIC.cpp',
                'PIC_init.ah'
              ]
            },
            {
              'vname' => 'RTC',
              'name' => 'ciao_platform_hw_dev_rtc',
              'depends' => '&dev_rtc',
              'files' => [
                'RTC.h',
                'RTC.cpp'
              ]
            },
            {
              'vname' => 'PIT - Programmable Interval Timer',
              'name' => 'ciao_platform_hw_dev_pit',
              'comp' => [
                {
                  'depends' => '&dev_pit',
                  'files' => [
                    'PIT.h',
                    'PIT.cpp',
                    'PIT_init.ah'
                  ]
                },
                {
                  'depends' => '&irq_pit',
                  'dir' => 'src/hw/irq',
                  'files' => [
                    'IRQ_PIT.h',
                    'IRQ_PIT.cpp',
                    'IRQ_PIT_Init.ah'
                  ]
                }
              ]
            },
            {
              'vname' => 'KeyboardCtrl',
              'name' => 'ciao_platform_hw_dev_keyboardctrl',
              'depends' => '&dev_keyboardctrl',
              'comp' => [
                {
                  'files' => [
                    'Key.h',
                    'KeyboardCtrl.h',
                    'KeyboardCtrl.cpp',
                    'KeyboardCtrl_init.ah'
                  ]
                },
                {
                  'depends' => '&dev_keyboardctrl_layout_en',
                  'file' => 'KeyboardCtrl_en.cpp'
                },
                {
                  'depends' => '&dev_keyboardctrl_layout_de',
                  'file' => 'KeyboardCtrl_de.cpp'
                }
              ]
            },
            {
              'vname' => 'Keyboard Interrupt Source',
              'name' => 'ciao_platform_hw_dev_keyboardirq',
              'depends' => '&irq_keyboard',
              'dir' => 'src/hw/irq',
              'files' => [
                'IRQ_Keyboard.h',
                'IRQ_Keyboard.cpp',
                'IRQ_Keyboard_Init.ah'
              ]
            },
            {
              'vname' => 'PCI Bus',
              'name' => 'ciao_platform_hw_dev_pci',
              'depends' => '&dev_pci',
              'files' => [
                'PCI.h',
                'PCI.cpp',
                'PCI_init.ah'
              ]
            },
            #TODO: RTL8139?
            {
              'vname' => 'COM - serial ports',
              'name' => 'ciao_platform_hw_dev_arch_com',
              'depends' => '&dev_com1',
              'comp' => [
                {
                  'files' => [
                    'COM.h',
                    'COM.cpp'
                  ]
                },
                {
                  'files' => [
                    'COM1.h',
                    'COM1.cpp',
                    'COM1_init.ah'
                  ]
                },
                {
                  'dir' => 'src/hw/irq',
                  'files' => [
                    'IRQ_COM1.h',
                    'IRQ_COM1.cpp',
                    'IRQ_COM1_init.ah'
                  ]
                }
              ]
            },
            {
              'vname' => 'COM_DebugPortAdapter',
              'name' => 'ciao_platform_hw_dev_com_debugport_adapter',
              'depends' => '&hal_debugport_dev_com',
              'file' => 'COM_DebugPort_Adapter.h'
            },
            {
              'vname' => 'Intel e1000 Network Adapter',
              'name' => 'ciao_platform_hw_dev_e1000',
              'depends' => '&dev_e1000',
              'comp' => [
                {
                  'files' => [
                    'E1000.h',
                    'E1000.cpp',
                    'E1000_init.ah'
                  ]
                },
                {
                  'dir' => 'src/hw/irq',
                  'files' => [
                    'IRQ_E1000.h',
                    'IRQ_E1000.cpp',
                    'IRQ_E1000_init.ah'
                  ]
                },
                {
                  'depends' => '&dev_e1000_receiver',
                  'files' => [
                    'E1000_receiver.ah',
                    'E1000_receiver_slice.ah'
                  ]
                },
                {
                  'depends' => '&dev_e1000_sender',
                  'files' => [
                    'E1000_sender.ah',
                    'E1000_sender_slice.ah'
                  ]
                },
                {
                  'depends' => '&dev_e1000_receiver_offloading',
                  'file' => 'E1000_receiver_offloading.ah'
                },
                {
                  'depends' => '&dev_e1000_sender_offloading',
                  'file' => 'E1000_sender_offloading.ah'
                },
                {
                  'depends' => '&hal_paging',
                  'file' => 'E1000_paging.ah'
                }
              ]
            },
            {
              'vname' => 'Virtio Net',
              'name' => 'ciao_platform_hw_dev_virtio_net',
              'depends' => '&dev_virtio_net',
              'comp' => [
                {
                  'files' => [
                    'VirtioNet.h',
                    'VirtioNet.cpp',
                    'VirtioNet_init.ah'
                  ]
                },
                {
                  'dir' => 'src/hw/irq',
                  'files' => [
                    'IRQ_VirtioNet.h',
                    'IRQ_VirtioNet.cpp',
                    'IRQ_VirtioNet_init.ah'
                  ]
                }
              ]
            },
            {
              'vname' => 'hw::irq::TRAP_PageFault',
              'name' => 'ciao_platform_hw_dev_irq_pagefault',
              'depends' => '&hal_pagefault_isr',
              'dir' => 'src/hw/irq',
              'files' => [
                'TRAP_PageFault.h',
                'TRAP_PageFault.cpp',
                'TRAP_PageFault_init.ah'
              ]
            },
            #TODO: guest SIG*-Handler
            {
              'vname' => 'VirtioPCI',
              'name' => 'ciao_platform_hw_dev_virtio_pci',
              'depends' => '&dev_virtio',
              'file' => 'VirtioPCI.h'
            },
            {
              'vname' => 'x87_FPU',
              'name' => 'ciao_platform_hw_dev_x87fpu',
              'depends' => '&dev_x87',
              'files' => [
                'x87_FPU.h',
                'x87_FPU_init.ah'
              ]
            },
            {
              'vname' => 'hlt in idleLoop()',
              'name' => 'ciao_platform_hw_dev_hlt',
              'depends' => '&dev_hlt',
              'file' => 'hlt.ah'
            }
            #TODO: MB Simulator
            #-----------------dev/irq end------------------------->
          ]
        }
        #TODO: guest devices
      ]
    },
#############################################################################################
    {
      'vname' => 'x86',
      'name' => 'ciao_platform_hw_arch',
      'comp' => [
        {
          'vname' => 'x86 Assembler Startup Code',
          'name' => 'ciao_platform_hw_arch_boot',
          'dir' => 'lib',
          'comp' => [
            {
              'vname' => '[CIAO_LINKFIRST]',
              'name' => 'ciao_platform_hw_arch_boot_make',
              'comp' => [
                {
                  'depends' => '&platform_native', #TODO: hier gibts noch was mit 4K alignment
                  'dir' => 'make',
                  'generate' => 'sprintf("CIAO_LINKFIRST += \$(LIB_DIR)/crt0.o -T \$(LIB_DIR)/sections.x -nostdlib\n")',
                  'file' => 'ciao_config.mk'
                },
                {
                  'depends' => '&platform_guest',
                  'dir' => 'make',
                  'generate' => 'sprintf("CIAO_LINKFIRST += \$(LIB_DIR)/crt0.o\n")',
                  'file' => 'ciao_config.mk'
                }
              ]
            },
            {
              'vname' => 'Linker Files',
              'name' => 'ciao_platform_hw_arch_boot_linker',
              'comp' => [
                {
                  'srcdir' => 'src/hw',
                  'file' => 'sections.x'
                }
              ]
            },
            {
              'vname' => 'Boot Files',
              'name' => 'ciao_platform_hw_arch_boot_boot',
              'comp' => [
                {
                  'vname' => 'native',
                  'name' => 'ciao_platform_hw_arch_boot_boot_native',
                  'depends' => '&platform_native',
                  'comp' => [
                    {
                      'dir' => 'src',
                      'srcdir' => 'src/hw/',
                      'file' => 'bootsect.asm16'
                    },
                    {
                      'dir' => 'src',
                      'srcdir' => 'src/hw/',
                      'file' => 'setup.asm16'
                    },
                    {
                      'depends' => '&architecture_ia32',
                      'dir' => 'src',
                      'srcdir' => 'src/hw/',
                      'file' => 'crt0.asm'
                    },
                    {
                      'depends' => '&architecture_x86_64',
                      'dir' => 'src',
                      'srcdir' => 'src/hw/',
                      'file' => 'crt0.asm',
                      'srcfile' => 'crt0-64.asm'
                    },
                    {
                      'depends' => '&boot_grub',
                      'srcdir' => 'src/hw',
                      'file' => 'grub-floppy.img'
                    },
                    {
                      'depends' => '&boot_grub2',
                      'srcdir' => 'src/hw',
                      'file' => 'grub2-floppy.img'
                    }
                  ]
                },
                {
                  'vname' => 'guest',
                  'name' => 'ciao_platform_hw_arch_boot_boot_guest',
                  'depends' => '&platform_guest',
                  'comp' => [
                    {
                      'dir' => 'src',
                      'srcdir' => 'src/hw/',
                      'file' => 'crt0.asm',
                      'srcfile' => 'crt0-guest.asm'
                    }
                  ]
                }
              ]
            }
          ]
        },
        {
          'vname' => 'C++ Startup',
          'name' => 'ciao_platform_hw_arch_cppstartup',
          'comp' => [
            {
              'dir' => 'src/hw/',
              'file' => 'x86_userinit.cpp'
            },
            {
              'vname' => 'GDT setup',
              'name' => 'ciao_platform_hw_arch_gdtsetup',
              'depends' => '&platform_global_descriptor_table',
              'dir' => 'src/hw/',
              'comp' => [
                {
                  'files' => [
                    'GDT.h',
                    'GDT.cpp',
                    'GDT_init.ah'
                  ]
                },
                {
                  'vname' => 'load new 32-bit code segment',
                  'name' => 'ciao_platform_hw_arch_startup_gdt_code32',
                  'depends' => '&architecture_ia32',
                  'file' => 'GDT_code32.ah'
                },
                {
                  'vname' => 'GDT 32-Bit Code Segment Descriptor Value',
                  'name' => 'ciao_platform_hw_arch_startup_gdt_code_segment_value_32',
                  'depends' => '&architecture_ia32',
                  'generate' => 'sprintf("#define X86_CODE_SEGMENT_DESCRIPTOR_VALUE 0x00CF9A000000FFFFULL\n")',
                  'file' => 'GDT_flags.h'
                },
                {
                  'vname' => 'GDT 64-Bit Code Segment Descriptor Value',
                  'name' => 'ciao_platform_hw_arch_startup_gdt_code_segment_value_64',
                  'depends' => '&architecture_x86_64',
                  'generate' => 'sprintf("#define X86_CODE_SEGMENT_DESCRIPTOR_VALUE 0x00AF9A000000FFFFULL\n")',
                  'file' => 'GDT_flags.h'
                },
                {
                  'depends' => '&hal_contextswitch_tss',
                  'generate' => 'sprintf("#define X86_TSS 1\n")',
                  'file' => 'GDT_TSS_flags.h'
                },
                {
                  'depends' => 'not &hal_contextswitch_tss',
                  'generate' => 'sprintf("#define X86_TSS 0\n")',
                  'file' => 'GDT_TSS_flags.h'
                }
              ]
            }
          ]
        },
        {
          'vname' => 'Multiboot Information',
          'name' => 'ciao_platform_hw_arch_multiboot',
          'comp' => [
            {
              'dir' => 'src/hw/',
              'file' => 'multiboot.h'
            }
          ]
        },
        {
          'vname' => 'Architecture',
          'name' => 'ciao_platform_hw_arch_architecture',
          'comp' => [
            {
              'depends' => '&architecture_ia32',
              'dir' => 'make',
              'generate' => 'sprintf("CXXFLAGS += -m32\nLDFLAGS += -melf_i386\nNASMFLAGS += -f elf32\n")',
              'file' => 'ciao_config_arch.mk'
            },
            {
              'depends' => '&architecture_x86_64',
              'dir' => 'make',
              'generate' => 'sprintf("CXXFLAGS += -m64 -mno-sse -mno-sse2 -mno-sse3 -mno-sse4 -mno-ssse3 -mno-sse4.1 -mno-sse5 -mno-sse4.2 -mno-sse4a\nLDFLAGS += -melf_x86_64\nNASMFLAGS += -f elf64\n")',
              'file' => 'ciao_config_arch.mk'
            },
            {
              'depends' => '&architecture_x86_64', #TODO: Puma Workaround
              'dir' => 'src',
              'srcdir' => 'src/hw/', #TODO: ??? so richtig ???
              'file' => 'puma.config',
              'srcfile' => 'puma.config-64'
            }
          ]
        },
        {
          'vname' => 'GRUB2',
          'name' => 'ciao_platform_hw_arch_grub2',
          'depends' => '&boot_grub2',
          'comp' => [
            {
              'dir' => 'src/hw/',
              'file' => 'grub2.cfg'
            }
          ]
        },
        {
          'vname' => 'supervisor mode',
          'name' => 'ciao_platform_hw_hal_arch_sysmode',
          'depends' => '&hal_protection_sysmode',
          'dir' => 'src/hw/',
          'files' => [
            'sysmode.ah',
            'SystemMode.h',
            'SystemMode.cpp'
          ]
        }
      ]
    }    
  ]
}

              

