#ifndef USERCODE1_H_
#define USERCODE1_H_

#include "stdint.h"
#include "app/componentheader.h"
#include "../cfAttribs.h"

CIAO_COMPONENT(InitTaskComponent)
	TASKDECL(InitTask);
	TASKDECL(restartDMATask);
};

class CopterControl;
class CopterControlTelemetry;

CIAO_COMPONENT(CopterControlComponent)
	TASKDECL(CopterControlTask);
	TASKDECL(CopterControlTelemetryTask);
	static void functionISRRadioISR();
    private:
    static CopterControl cc;
    static CopterControlTelemetry cct;
};

class SignalProcessing;
class SignalProcessingTelemetry;

CIAO_COMPONENT(SignalProcessingComponent)
	TASKDECL(SignalProcessingTask);
	TASKDECL(SignalProcessingTelemetryTask);
private:
	static SignalProcessing sp;
	static SignalProcessingTelemetry spt;
};

#ifdef cfcopter_flightcontrol_c
class FlightControl;
class FlightControlTelemetry;

CIAO_COMPONENT(FlightControlComponent)
	private:
		TASKDECL(FlightControlTask);
		TASKDECL(FlightControlTelemetryTask);

		static FlightControl flightCtl;
		static FlightControlTelemetry fct;
};
#endif

class Navigation;
class NavigationTelemetry;

CIAO_COMPONENT(NavigationComponent)
		TASKDECL(NavigationTask);
		TASKDECL(NavigationTelemetryTask);
	private:
		static Navigation navi;
		static NavigationTelemetry naviTele;
};

class SPICom;

#ifdef cfcopter_spicom_c
CIAO_COMPONENT(SPIComComponent)
	TASKDECL(SPIComTask);
	static void functionISRSPIInterrupt();
	static void functionISRSPIErrorInterrupt();
private:
	static SPICom spiCom;
};
#endif

class Ethernet;

CIAO_COMPONENT(EthernetComponent)
	TASKDECL(EthernetTask);
private:
	static Ethernet eth;
};


CIAO_COMPONENT(IPStackComponent)
	TASKDECL(IPStackTask);
	static void functionISRNetworkISR();
};

#endif /*USERCODE1_H_*/
