#include "appcode.h"
#include "objects.h"
#include "as/AS.h"
#include "app/componentheader.h"
#include <stdio.h>

#include "tc1796b/scu.h"
#include "tc1796b/ebu/addr.h"
#include "tc1796b/pmi/addr.h"

extern "C" {
/* initialization values for External Bus */
#define VAL_EBU_CON			0x0000FF68
#define VAL_EBU_BFCON		0x001001D0
/* CS0: 1 MB external MRAM */
#define VAL_EBU_ADDRSEL0	0xA1000873
#define VAL_EBU_BUSCON0		0x00920000
#define VAL_EBU_BUSAP0		0x81200010
/* CS1: 4 MB external Flash (not used) */
#define VAL_EBU_ADDRSEL1	0xA4000853
#define VAL_EBU_BUSCON1		0x00920000
#define VAL_EBU_BUSAP1		0xC7B30000
/* CS2 is used for USB controller */
#define VAL_EBU_ADDRSEL2	0xD90000C1
#define VAL_EBU_BUSCON2		0x00420000
#define VAL_EBU_BUSAP2		0x40D809F0
/* CS3 is used for LAN controller */
#define VAL_EBU_ADDRSEL3	0xD80000C1
#define VAL_EBU_BUSCON3		0x00820000
#define VAL_EBU_BUSAP3		0x40D80000

/* enable instruction cache */
#define VAL_PMI_CON0		0x00000000

	typedef struct
	{
		unsigned long addr;
		unsigned long val;
	} InitTab_t;

	const InitTab_t boardSetupTab[] =
	{
		{EBU_ADDRSEL0_ADDR,	VAL_EBU_ADDRSEL0},
		{EBU_BUSCON0_ADDR,	VAL_EBU_BUSCON0	},
		{EBU_BUSAP0_ADDR,	VAL_EBU_BUSAP0	},
		{EBU_ADDRSEL1_ADDR,	VAL_EBU_ADDRSEL1},
		{EBU_BUSCON1_ADDR,	VAL_EBU_BUSCON1	},
		{EBU_BUSAP1_ADDR,	VAL_EBU_BUSAP1	},
		{EBU_ADDRSEL2_ADDR,	VAL_EBU_ADDRSEL2},
		{EBU_BUSCON2_ADDR,	VAL_EBU_BUSCON2	},
		{EBU_BUSAP2_ADDR,	VAL_EBU_BUSAP2	},
		{EBU_ADDRSEL3_ADDR,	VAL_EBU_ADDRSEL3},
		{EBU_BUSCON3_ADDR,	VAL_EBU_BUSCON3	},
		{EBU_BUSAP3_ADDR,	VAL_EBU_BUSAP3	},
		/*
			This must be done after CSx programming to avoid disabling EBU_CON.CS0FAM
			(CS0 Fills Address Map)
		 */
		{EBU_CON_ADDR,		VAL_EBU_CON		},
		{EBU_BFCON_ADDR,	VAL_EBU_BFCON	},
	};
	
	const unsigned long boardSetupTabSize = sizeof(boardSetupTab) / sizeof(InitTab_t);

void __board_init (void) __attribute__((interrupt));
void __board_init (void) {
	InitTab_t* lauf = (InitTab_t*)boardSetupTab;
	while ( lauf != boardSetupTab +  boardSetupTabSize ) {
		*((uint32_t *)lauf->addr) = lauf->val;
		lauf++;
	}
}

void run_app_hw_init(){
}
}

TASKDEF(SPIComComponent, SPIComTask) {
	while(1) {
		AS::WaitEvent(PacketWaitingEvent);
		AS::ClearEvent(PacketWaitingEvent);
	}
	AS::TerminateTask();
}

void SPIComComponent::functionISRSPIInterrupt() { }
