/*! \file This file defines a simple Structure for commands that the
 *        FSM can handle
 */

#ifndef __COMMAND_H__
#define __COMMAND_H__

/*! This typedef enumerates all possible command types */
typedef enum {
		MOVE_START, /* This type is only used by the generator, it must not get into a sequence for the fsm */
		MOVE_UP,
		MOVE_DOWN,
		MOVE_RELEASE,
		MOVE_HOLD,
		MOVE_END
	} movetype;

/*! a struct that represents a FSM command */
typedef struct {
	/*! \brief This is the type of a command */
	movetype mtype;
	
	/*! \brief n is a mtype dependant number that will be used by the FSM */
	int n;
} command;

#endif /* __COMMAND_H__ */
