/*! \file A sequence represents complete command chain that will
 *        be executed of the fsm.
 */

#ifndef __SEQUENCE_H__
#define __SEQUENCE_H__

#include "command.h"

/*! This function enables the output of commands other than MOVE_END
 */
void SEQUENCE_Start();

/*! This function gets the next command from the sequencs that has to be executed
 *  
 *  \attention This method automatically increases the internal pointer to
 *             the next command. Do not call this method in more tha one place,
 *             or the output commands won't be a valid sequence of commands.
 */
command SEQUENCE_GetCommand();

#endif /* __SEQUENCE_H__ */

