#include "coil.h"
#include "hw/dev/P0.h"

static char COIL_active_coil;

void COIL_Init()
{
	int i;
	for (i = 5; i <= 12; i++) {
		hw::dev::P0::setMode(i, hw::dev::P0::OUTPUT_PUSHPULL);
	}

	COIL_AllOff();
}

void COIL_On(char coilno)
{
	if ((coilno < 0) || (coilno > 7))
		return;
		
	if (COIL_active_coil != -1)
		COIL_Off(COIL_active_coil);
		
	hw::dev::P0::set(coilno+5);
	
	COIL_active_coil = coilno;
}

void COIL_Off(char coilno)
{
	if ((coilno < 0) || (coilno > 7))
		return;
	
	hw::dev::P0::clear(coilno+5);
	
	if (COIL_active_coil == coilno)
		COIL_active_coil = -1;
}

void COIL_AllOff()
{
	int i;
	for (i = 5; i <= 12; i++)
		hw::dev::P0::clear(i);
	
	COIL_active_coil = -1;
}

bool COIL_Status(char coilno)
{
	if ((coilno < 0) || (coilno > 7))
		return false;
		
	return hw::dev::P0::get(coilno+5);
}


int COIL_Current()
{
	return COIL_active_coil;
}
