#ifndef COIL_H_
#define COIL_H_

/*! This function initializes the COIL module so that
 *  it can be used
 */
void COIL_Init();

/*! This function switches on the coil with the number coilno
 *  which has to be 0 up to NUM_COILS-1.
 *  If another coil is activated in this moment, it will be switched
 *  off before.
 *  
 *  /param coilno The number of the coil that has to be switched on
 */
void COIL_On(char coilno);

/*! This function switches off the coil with the number coilno
 *  which has to be 0 up to NUM_COILS-1.
 *  If the coilno-Coil isn't switched on at the time of call 
 *  nothing happens, even if another coil is activated.
 *  
 *  /param coilno The number of the coil that has to be switched off
 */
void COIL_Off(char coilno);

/* This function switches off all coils
 */
void COIL_AllOff();

/*! This function gets the actual status of the coilno-coil
 *
 *  /param coilno The number of the coil of which status has to be checked
 *  /return True if coil i s switched on (CHECK THIS)
 */
bool COIL_Status(char coilno);

/*! This function gets the number of the current switched on coil
 *  
 *  /return Number [0...NUM_COILS-1] if a coil is activated or -1 if no coil is activated
 */
int  COIL_Current();

#endif /*COIL_H_*/
