#ifndef __CONFIGMODUL_H__
#define __CONFIGMODUL_H__

#include "control/command.h"

struct struct_config;

typedef struct struct_config_elem {
	command cmd;
	struct struct_config_elem* next;
	struct struct_config_elem* prior;
} config_elem_t;

typedef struct struct_config {
	char currentCoil;  /* Do not change this, it is internally used to check coil boundaries of a config */
	config_elem_t* firstElem;
	config_elem_t* lastElem;
} config_t;

config_t* CFG_Create();
void CFG_Delete(config_t* config);

void CFG_AddUp(config_t* config, int n);
void CFG_AddDown(config_t* config, int n);
void CFG_AddHold(config_t* config, int timeInMS);
void CFG_AddRelease(config_t* config, int timeInMS);
void CFG_AddEnd(config_t* config);

#endif

