#ifndef __PROGRAM_H__
#define __PROGRAM_H__

#include <common/common.h>

typedef enum {
	start,
	up_continuous,
	down_continuous,
	osc_continuous,
	up_stepwise,
	down_stepwise,
	osc_stepwise,
	hold
} prog_elem_type_t;

struct struct_program;

typedef struct struct_prog_elem {
	prog_elem_type_t type;
	int n;
	int rounds;
	struct struct_prog_elem* next;
	struct struct_prog_elem* prior;
} prog_elem_t;

typedef struct struct_program {
	prog_elem_t* firstElem;
	prog_elem_t* lastElem;
	int errorPos;
	int currentCoil; /* This will only be changed internally in CTRL-Module in a temporary program */
} program_t;

program_t* NewProgram();
void DeleteProgram(program_t* program);

void UpContinuous(program_t*, int);
void DownContinuous(program_t*, int);
void UpStepwise(program_t*, int);
void DownStepwise(program_t*, int);
void OscContinuous(program_t*, int, int);
void OscStepwise(program_t*, int, int);
void Hold(program_t*, int);

#endif
