my $APPNAME = $ENV{'PWD'};
$APPNAME =~ s/^.*\///;

$VAR=	{
	'vname' => $APPNAME,
	'name' => "app_$APPNAME",
	'dir'  => "app/$APPNAME",
	'comp' => [

	# The C variant of the application source files.
	# Only copied when the C variant is selected
	#
	# You may have multiple such blocks in this file if your application
	# has multiple components that exist in either a Java or C variant
	#
	# KESO parts are directly created into the variant directory
	# and need not be specified here
	{
		vname => "application C code",
		depends => "&###SKEL###_c",
		files => [
			'*.c',
			'*.cc',
			'*.cpp',
			'*.h',
			'*.hpp',
			'*.ah',
		],
	},

	# Parts of the application that are always required, because there
	# is no Java alternative to them
	{
		vname => "application C code without Java alternative",
		files => [
		],
	},

	# common files
	{
		'vname' => 'Common Files',
		'files' => [
			"$APPNAME.config",
			'run.cmm',
		],
	},

	# Makefile for compiling the variant
	{
		'srcfile' => 'Makefile.app',
		'file' => 'Makefile',
	},

	# uses the config.xml file provided by KESO
	{
		vname => "config.xml",
		depends => "&###SKEL###_java",
		'create_symlink' => [ "Keso_$APPNAME/config.xml", 'config.xml' ],
	},
	
	# generated config.xml, use only if there are _NO_ KESO components
	# 
	# be sure to adjust the dependencies of this target if you create multiple
	# alternate Java/C components
	{
		vname => "config.xml",
		depends => "&###SKEL###_c",
		'generate'=>'generate_config_xml();',
		'file' => 'config.xml',
	},
	],
};
