/*
 * $Id: triboard1796.cpp 1211 2010-07-16 13:05:25Z sijesche $
 * created:   04.03.2006 lohmann
 */
 
/** 
 * \file triboard1796.cpp
 * \brief tricore-specific functions and startup-code
 */

#include "hw/hal/CPU.h"
#include "hw/init.h"
#include "ciaoConfig.h"
#include "util/assert.h"

#include <tc1796b/scu.h>

#include "hw/dev/CGU.h"


namespace hw { namespace _tc {

#define WDTCON0         *((volatile unsigned int *) 0xf0000020)
#define WDTCON1         *((volatile unsigned int *) 0xf0000024)


void unlock_wdtcon() {
	unsigned int wcon0, wcon1;
	volatile unsigned int wcon0_res;
	
	wcon0 = WDTCON0;
	wcon1 = WDTCON1;
	wcon0 &= 0xffffff03;
	wcon0 |= 0xf0;
	wcon0 |= (wcon1 & 0xc);
	wcon0 ^= 0x2;
	WDTCON0 = wcon0;
	wcon0 &= 0xfffffff0;
	wcon0 |= 0x2;
	WDTCON0 = wcon0;
	/* read back new value ==> synchronise LFI */
	wcon0_res = WDTCON0;
}

/* Lock (set) the ENDINIT bit.  */
void lock_wdtcon () {
	unsigned int wcon0, wcon1;
	volatile unsigned int wcon0_res;
	
	wcon0 = WDTCON0;
	wcon1 = WDTCON1;
	wcon0 &= 0xffffff03;
	wcon0 |= 0xf0;
	wcon0 |= (wcon1 & 0xc);
	wcon0 ^= 0x2;
	WDTCON0 = wcon0;
	wcon0 &= 0xfffffff0;
	wcon0 |= 0x3;
	WDTCON0 = wcon0;
	/* read back new value ==> synchronise LFI */
	wcon0_res = WDTCON0;
}
		
	
	
}} // namespace hw::_tc
