/*
 * RTC.h
 *
 *  Created on: 22.06.2010
 *      Author: bossel00
 */

#ifndef RTC_H_
#define RTC_H_

#include "stdinc.h"

namespace hw {
namespace dev {

class RTC {
public:
	class Time {
		static const char* WEEKDAYS[];
		static const char* MONTHS[];

		int hour_, minute_, second_, weekday_, day_, month_, year_;

		friend class hw::dev::RTC;

	public:
		int getHour() { return hour_; }
		int getMinute() { return minute_; }
		int getSecond() { return second_; }

		int getWeekday() { return weekday_; } // returns [1-7], 1 == Sunday, 2 == Monday, ...
		const char* getWeekdayName() { return WEEKDAYS[getWeekday() - 1]; }

		int getDay() { return day_; }

		int getMonth() { return month_; }
		const char* getMonthName() { return MONTHS[getMonth() - 1]; }

		int getYear() { return year_; }
	};

private:
	// TODO: I/O-Ports mit p::v konfigurierbar machen
	static const int CMOS_INDEX = 0x70;
	static const int CMOS_DATA  = 0x71;

public:
	static Time getCurrentTime();

	// TODO: setCurrentTime(const Time&) implementieren
};

}
}

#endif
