/*
 * VirtioPCI.h
 *
 *  Created on: Mar 8, 2010
 *      Author: bossel00
 */

#ifndef VIRTIOPCI_H_
#define VIRTIOPCI_H_

#include "stdinc.h"
#include "IOPort.h"

namespace hw {
namespace dev {

class VirtioPCI {

protected:

	enum {
		VIRTIO_CONFIG_S_ACKNOWLEDGE = 1,
		VIRTIO_CONFIG_S_DRIVER = 2,
		VIRTIO_CONFIG_S_DRIVER_OK = 4,
		VIRTIO_CONFIG_S_FAILED = 0x80
	};

	struct {
		IOPort host_features;		// 32-Bit
		IOPort guest_features;		// 32-Bit
		IOPort vring_page_num;		// 32-Bit
		IOPort vring_ring_size;		// 16-Bit
		IOPort vring_queue_selector;	// 16-Bit
		IOPort vring_queue_notifier;	// 16-Bit
		IOPort status;				//  8-Bit
		IOPort pci_isr;			//  8-Bit
		IOPort config;				// xx-Bit

		void setBaseAddress(UInt16 base) {
			host_features.setAddress(base + 0);
			guest_features.setAddress(base + 4);
			vring_page_num.setAddress(base + 8);
			vring_ring_size.setAddress(base + 12);
			vring_queue_selector.setAddress(base + 14);
			vring_queue_notifier.setAddress(base + 16);
			status.setAddress(base + 18);
			pci_isr.setAddress(base + 19);
			config.setAddress(base + 20);
		}
	} io_;

};

}
}

#endif /* VIRTIOPCI_H_ */
