/*
 * x87_FPU.h
 *
 *  Created on: 20.04.2010
 *      Author: bossel00
 */

#ifndef X87_FPU_H_
#define X87_FPU_H_

namespace hw {
namespace dev {

class x87_FPU {
	static x87_FPU inst_;

public:
	static x87_FPU& Inst() { return inst_; }

	void init() {
		asm volatile("finit");
	}

	// save context to ctx (108 bytes required)
	void save(void* ctx) {
		asm volatile("fsave %0" : "=m"(*(unsigned*)ctx) : : "memory");
	}

	// load context from ctx
	void load(const void* ctx) {
		asm volatile("frstor %0" : : "m"(*(unsigned*)ctx));
	}
};

}
}

#endif /* X87_FPU_H_ */
