/** \author Christian Meier
 *  \version $Id: CanDriverImpl.h 995 2009-08-11 14:26:31Z mike $
 *
 *  \brief Implementation of tc's multican hardware unit
 */

#ifndef HW_DEV_CAN_MULTICAN_CAN_DRIVER_IMPL_H
#define HW_DEV_CAN_MULTICAN_CAN_DRIVER_IMPL_H

#include "os/com/ComStack_Types.h"
#include "hw/dev/can/ConfigTypes.h"

#include "Cfg.h"
#include "ControllerMapping.h"

#include "HwObject.h"
#include "Controller.h"
#include "ListManager.h"
#include "ClockManager.h"
#include "PendingHwObjManager.h"

#include "Addr.h"

namespace hw { namespace dev { namespace can { namespace multican {

class CanDriverImpl {
public:	// Workaround for canif_Cfg.cpp
	static CanDriverImpl theMultican_;

protected:
	CanDriverImpl() {}

public:
	static CanDriverImpl&
	Inst(void) {
		return theMultican_;
	}

	static void const *
	Hndl() {
		return (void const *) &theMultican_;
	}

	void
	Init (const ConfigType * p_Config);

	void
	InitController (ControllerIdType Controller, ControllerConfigType const * p_Config);

	ReturnType
	SetControllerMode (ControllerIdType Controller, StateTransitionType Transition);

	void
	DisableControllerInterrupts (ControllerIdType Controller);

	void
	EnableControllerInterrupts (ControllerIdType Controller);

	void
	MainFunction_BusOff (void);

	void
	ProcessBusoff(uint8 ControllerHandle);

private:
	uint8 _DisableInterruptCounter[cfHW_DEV_CAN_MULTICAN_NUM_CONTROLLERS];
}; // class  hw::dev::can::multican::CanDriverImpl

}}}}

#endif /* HW_DEV_CAN_MULTICAN_CAN_DRIVER_IMPL_H */
