// $Id$

#ifndef __HW_HAL_AST1_H__
#define __HW_HAL_AST1_H__

#include "stdinc.h"
#include "AST1Impl.h"


namespace hw { namespace hal {


class AST1 : public AST1Impl {
 public:
 	typedef AST1Impl Super;

 private:
	static AST1 theAST1_;
	void init() {
		Super::init();
		enable();
	}

 public:
	//! Returns the one-and-only AST1 instance.
	static AST1& Inst() {
		return theAST1_;
	}
	
	//! Trigger the AST1 to the CPU
	void trigger() {
		Super::trigger();
	}
	
	//! From now on, AST1 execution triggered by threads will be delayed.
	void beginDelay() {
		Super::beginDelay();
	}
	
	//! Ends a delay period started by beginDelay(), invokes pending AST1 execution.
	void endDelay() {
		Super::endDelay();
	}
	
	static void ast() {
		// Invoked by advice
		// bound to by advice
	} 
};

}} // namespace hw::hal

#endif // __HW_HAL_AST1_H__
