// $Id: DebugPort.cpp 1309 2010-11-17 20:33:43Z mike $
#include "DebugPort.h"
#include "hw/hal/CPU.h"

// the following function is imported by libcmini as
// stdout device
extern "C" int __ciao_stdio_putc( char ch ) {
	
	/*lock interrupts, because following race condition could occur
	 * (at least on TriCore)
	 * 	Thread							Interrupt
	 *	- <serialdev>.send				
	 * 									- something long enough
	 *					>>>the serial dev sets RTS<<<
	 *  - <serialdev>.clearRTS
	 * 
	 * => hang on next output*/

	if(ch != '\0') {	
		hw::hal::CPU::IEState old;
		hw::hal::CPU::disable(old);
		hw::hal::DebugPort::Inst().putc_( ch );
		hw::hal::CPU::enable(old);
	}
	return 1;	// success
}


namespace hw { namespace hal {

/**
 * Instance of the debug Port
 * FIXME: MORE DOCU
 */
DebugPort DebugPort::theDebugPort_;

}} // namespace hw::hal
