// $Id: STMTimer.cpp 239 2006-06-10 00:40:03Z lohmann $
// Created:   22.05.2006 lohmann

/**
 * @file STMTimer.cpp
 * @brief Implementation of the TC1796 STMTimer0 and STMTimer1 classes
 */

#include "STMTimer1.h"
#include "CPU.h"

namespace hw { namespace hal {

using namespace hw::dev;

STMTimer1 STMTimer1::theSTMTimer1_;

void STMTimer1::init() {
	// nothing to do...

	// STM::init() already did everything
}

void STMTimer1::windupAndStart( Unit time ) {
	STM::CMCON().bits.MSIZE1	= 31;
	STM::CMCON().bits.MSTART1	= 0;

	// windup and start
	CPU::IEState ie;
	CPU::disable( ie );
	hw::dev::STM::CMP1() = time;
	hw::dev::STM::ICR().bits.CMP1EN = 1;	// enable timer
	IRQ::enable();
	CPU::enable( ie );
}


}} // namespace hw::hal

