// $Id: ASTImpl_CPU_SRC0.h 995 2009-08-11 14:26:31Z mike $
// Created:   25.03.2006 lohmann

#ifndef __HW_HAL_ASTIMPL_CPUSRC0_H__
#define __HW_HAL_ASTIMPL_CPUSRC0_H__

#include "stdinc.h"
//#include "hw/irq/CPU_SRC0.h"
#include "CPU.h"

namespace hw {
namespace hal {

class ASTImpl_CPU_SRC0 { // : protected hw::irq::CPU_SRC0 {

	static bool triggered;
	static bool delayed;

	static void ast();

public:
	//typedef hw::irq::CPU_SRC0 Super;

	static void init() {
		triggered = false;
		delayed = false;
	}

	// relay? (Interrupt auf Epilogue-Ebene auslösen)
	//! Trigger the AST to the CPU
	static void trigger() {
		//Super::set();

		if (!delayed) {
			// TODO: Richtig?
			beginDelay();
			//Handler();
      CPU::enable(); //ast() should be run with interrupts enabled
			ast();
			endDelay();
		}
		else
			triggered = true;
	}

	// enter? (Epilogue-Ebene sperren)
	static void beginDelay() {
		// TODO: This does not work if CPU_SRC0 uses an IRQL > 1 and other ASTs are used
		// TODO: STATIC_ASSERT( Super::VECTOR == 1, AST0_implementation_requires_IRQL_1 );
		// TODO: hw::hal::CPU::setIRQL( Super::VECTOR );
		delayed = true;
	}

	// leave? (Epilogue-Ebene freigeben)
	//! Ends a delay period started by beginDelay(), invokes pending AST execution.
	static void endDelay() {
		//hw::hal::CPU::CPU::setIRQL( 0 );

		CPU::disable();

		while (triggered) {
			triggered = false;
			CPU::enable();
			//Handler();
			ast();
			CPU::disable();
		}

		delayed = false;

		CPU::enable();
	}

	// sti?
	static void enable() {
		beginDelay();
	}

	// cli?
	static void disable() {
		endDelay();
	}

	static bool Handler() {
		return true;
	}
};

}
} // namespace hw::hal

#endif // __HW_HAL_ASTIMPL_CPUSRC0_H__
