/*
 * InputDeviceKeyboard.cpp
 *
 *  Created on: 22.01.2010
 *      Author: bossel00
 */

#include "InputDeviceKeyboard.h"

namespace hw {
namespace hal {

// CiAO x86 AT-Keyboard decoder returns '\n' on <ENTER>
const char InputDeviceKeyboard::DEFAULT_NEWLINE_SEQUENCE[InputDeviceKeyboard::DEFAULT_NEWLINE_SEQUENCE_LENGTH] = { '\n' };

InputDeviceKeyboard InputDeviceKeyboard::inst_;

// returns the next character without removing it from buffer
int InputDeviceKeyboard::peekCharacter() {
	while (buffer_.isEmpty());
	return buffer_.peek();
}

// returns the next character
int InputDeviceKeyboard::getCharacter() {
	while (buffer_.isEmpty());
	return buffer_.get();
}

// returns # of characters in buffer
int InputDeviceKeyboard::charactersAvailable() const {
	// TODO: Ringbuffer::available implementieren und hier nutzen
	return ! buffer_.isEmpty();
}

}
}
