/**
 * \file InputDeviceSTDIN.h
 * \brief Implements a low-level interface for guest standard input
 *
 */

#ifndef __HW_HAL_INPUTDEVICESTDIN__
#define __HW_HAL_INPUTDEVICESTDIN__

namespace hw { namespace hal {

class InputDeviceSTDIN {
public:
	static const int  DEFAULT_NEWLINE_SEQUENCE_LENGTH = 1;
	static const char DEFAULT_NEWLINE_SEQUENCE[DEFAULT_NEWLINE_SEQUENCE_LENGTH];

private:
	static InputDeviceSTDIN inst_;

	char buffer;
	bool buffer_ok;

  public:
	  void init();
	  void fini();

  public:  // Userinterface
  	static InputDeviceSTDIN& Inst() {
  		return inst_;
  	}

  	// enables/disables echo
  	void echo(bool on);

  	// returns the next character without removing it from buffer
  	int peekCharacter();

  	// returns the next character
  	int getCharacter();

  	// returns # of characters in buffer
  	int charactersAvailable() const;

};

}} // namespace hw::hal



#endif // __HW_HAL_INPUTDEVICESTDIN__
