#include "OutputDeviceCGA.h"

#include "hw/dev/CGA.h"

namespace hw {
namespace hal {

OutputDeviceCGA OutputDeviceCGA::theOutputDevice_;

void OutputDeviceCGA::clearScreen() {
	hw::dev::CGA::Inst().clear(attribute_);
}

void OutputDeviceCGA::setCursorPosition(int x, int y) {
	hw::dev::CGA::Inst().setpos(x, y);
}

void OutputDeviceCGA::putCharacter(char c) {
	hw::dev::CGA::Inst().print(&c, 1, attribute_);
}

void OutputDeviceCGA::putString(const char* str, unsigned long size) {
	hw::dev::CGA::Inst().print(str, size, attribute_);
}

void OutputDeviceCGA::setAttribute(const OutputDeviceCGA::Attribute& attribute) {
	attribute_ = attribute;
}

void OutputDeviceCGA::resetAttribute() { // reset to default
	attribute_ = DEFAULT_ATTRIBUTE;
}

}
}
