#ifndef HW_HAL_CAN_CONFIG_TYPES_H
#define HW_HAL_CAN_CONFIG_TYPES_H

#include "hw/hal/can/ControllerConfigType.h"
#include "hw/hal/can/rx/CanDriverConfigType.h"
#include "hw/hal/can/tx/TxLpduIdType.h"
#include "hw/hal/can/tx/TxLpduConfigType.h"
#include "hw/hal/can/rx/RxLpduIdType.h"
#include "hw/hal/can/rx/RxLpduConfigType.h"
#include "hw/dev/can/ConfigTypes.h"

#define HW_HAL_CAN_CONFIG_TYPE_INITIALIZER(ControllerConfigs, ControllerConfigMultiplicity, TxLpduConfigs, TxLpduConfigMultiplicity, RxLpduConfigs, RxLpduConfigMultiplicity, CanDriverConfigs, CanDriverConfigMultiplicity)	\
	{ControllerConfigs, ControllerConfigMultiplicity, TxLpduConfigs, TxLpduConfigMultiplicity, RxLpduConfigs, RxLpduConfigMultiplicity, CanDriverConfigs, CanDriverConfigMultiplicity}

namespace hw { namespace hal { namespace can {

struct ConfigType {
	ControllerConfigType const * ControllerConfigs_;
	uint8 ControllerMultiplicity_;

	TxLpduConfigType const * TxLpduConfigs_;
	TxLpduIdStorageType TxLpduConfigMultiplicity_;

	RxLpduConfigType const * RxLpduConfigs_;
	RxLpduIdStorageType RxLpduConfigMultiplicity_;

	CanDriverConfigType const * CanDriverConfigs_;
	uint8 CanDriverConfigMultiplicity_;
};

}}}

#endif
