#ifndef HW_HAL_CAN_RX_LPDU_TYPE_H
#define HW_HAL_CAN_RX_LPDU_TYPE_H

#include "os/com/ComStack_Types.h"
#include "hw/hal/can/Cfg.h"

#include "RxLpduIdType.h"
#include "RxLpduConfigType.h"

namespace hw { namespace hal { namespace can {

class RxLpduType : private RxLpduConfigType {
public:
	inline void
	Init(RxLpduConfigType const * RxLpduConfig) {
		*(RxLpduConfigType *)this = *RxLpduConfig;
	}

	inline RxLpduIdType
	Id() const {
		return this - RxLpdus_;
	}

private:
	inline RxLpduType() {}

public:
	static void
	InitAll(RxLpduConfigType const * ConfigArray, RxLpduIdType RxLpduMultiplicity) {
		RxLpduIdType i = 0;

		// We assume RxLpduMultiplicity <= cfHW_HAL_CAN_RX_LPDU_MULTIPLICITY
		for(; i < RxLpduMultiplicity; ++i) {
			RxLpdus_[i].Init(&ConfigArray[i]);
		}

		RxLpduMultiplicity_ = i;
	}

	static RxLpduType&
	Inst(uint8 RxLpduId) {
		return RxLpdus_[RxLpduId];
	}

	static RxLpduIdType
	Multiplicity() {
		return RxLpduMultiplicity_;
	}

private:
	static RxLpduType RxLpdus_[cfHW_HAL_CAN_RX_LPDU_MULTIPLICITY];
	static RxLpduIdStorageType RxLpduMultiplicity_;
};

}}}

#endif
