// $Id: STM.h 995 2009-08-11 14:26:31Z mike $
// Created:   01.06.2006 lohmann


#ifndef STM_H_
#define STM_H_

#include "IRQBase.h"
#include <tc1796b/stm/addr.h>

namespace hw { namespace irq {

/**
 * @brief Provides access to TC1796 IRQ STM_SRC0
 *
 */
struct STM_SRC0 : public IRQBase< cfIRQL_STM_SRC0, STM_SRC0_ADDR  > {

	//! Advice should bind to this 
	static Bool Handler();
		
	//! The actual hardware handler just inlines Handler(), should not be affected by advice.
	static Bool cfHAL_IRQHANDLER_ATTRIBUTES HWHandler();
};

/**
* @brief Provides access to TC1796 IRQ STM_SRC1
 *
 */
struct STM_SRC1 : public IRQBase< cfIRQL_STM_SRC1, STM_SRC1_ADDR  > {

	//! Advice should bind to this 
	static Bool Handler();
		
	//! The actual hardware handler just inlines Handler(), should not be affected by advice.
	static Bool cfHAL_IRQHANDLER_ATTRIBUTES HWHandler();
};

}} // namespace hw::irq

#endif /*STM_H_*/

