#ifndef HW_IRQ_IRQ_IDE1_H_
#define HW_IRQ_IRQ_IDE1_H_

#include "stdinc.h"
#include "IRQBase.h"

namespace hw {
namespace irq {

/**
 * @brief IRQ for IDE1
 *
 */
class IRQ_IDE1: public IRQBase {

	typedef IRQBase Super;

public:
	static UInt8 REGISTER;

public:
	static void enable() {
		Super::enableIRQ(REGISTER);
	}
	static void disable() {
		Super::disableIRQ(REGISTER);
	}

	//! Advice should bind to this
	static Bool Handler();

	//! The actual hardware handler just inlines Handler(), should not be affected by advice.
	static Bool HWHandler();

	static void init(UInt8 vector) {
		REGISTER = vector;

		// +32 für Hardware-Unterbrechungen
		handler_table[REGISTER + 32] = HWHandler;
	}
};

} // namespace irq
} // namespace hw

#endif // HW_IRQ_IRQ_IDE1_H_
