#ifndef HW_IRQ_IRQ_KEYBOARD_H_
#define HW_IRQ_IRQ_KEYBOARD_H_

#include "stdinc.h"
#include "IRQBase.h"

namespace hw {
namespace irq {

/**
 * @brief Access to Keyboard Interrupt
 *
 */
class IRQ_Keyboard : public IRQBase {

	static const UInt8 IRQ_KEYBOARD_V = 1;

	typedef IRQBase Super;

public:
	static const UInt8 REGISTER = IRQ_KEYBOARD_V;

public:
	static void enable() {
		Super::enableIRQ(IRQ_KEYBOARD_V);
	}
	static void disable() {
		Super::disableIRQ(IRQ_KEYBOARD_V);
	}

	//! Advice should bind to this
	static Bool Handler();

	//! The actual hardware handler just inlines Handler(), should not be affected by advice.
	static Bool HWHandler();

	static void init() {
		// +32 für Hardware-Unterbrechungen
		handler_table[IRQ_KEYBOARD_V + 32] = HWHandler;
	}
};

} // namespace irq
} // namespace hw

#endif // HW_IRQ_IRQ_KEYBOARD_H_
