#ifndef HW_TRAP_PAGEFAULT_H_
#define HW_TRAP_PAGEFAULT_H_

#include "stdinc.h"
#include "IRQBase.h"

namespace hw {
namespace irq {

/**
 * @brief PageFault Handler
 *
 */
class TRAP_PageFault {

	static const UInt8 PAGEFAULT_TRAP_NR = 0xe;

public:

	//! Advice should bind to this
	static Bool Handler();

	//! The actual hardware handler just inlines Handler(), should not be affected by advice.
	static Bool HWHandler();

	static void init() {
		// +32 für Hardware-Unterbrechungen
		handler_table[PAGEFAULT_TRAP_NR] = HWHandler;
	}

	static void debugHandler();
};

} // namespace irq
} // namespace hw

#endif // HW_TRAP_PAGEFAULT_H_
