#ifndef OS_COM_ASCOM_RX_IPDU_GROUP_TYPE_H
#define OS_COM_ASCOM_RX_IPDU_GROUP_TYPE_H

#include "os/com/ascom/Cfg.h"
#include "os/com/ascom/ConfigTypes.h"
#include "util/container/Bitset.h"

namespace os { namespace com { namespace ascom {

class RxIpduGroupType : public RxIpduGroupConfigType {
public:
	static RxIpduGroupType &
	Inst (RxIpduGroupIdType RxIpduGroupId);

	static void
	InitAll (RxIpduGroupConfigType const * ConfigArray, RxIpduGroupIdType RxIpduGroupMultiplicity);

	RxIpduGroupIdType
	Id () const;

	void
	Init (RxIpduGroupConfigType const * Config);

	void
	Init ();

	void
	Start (Bool Initialize);

	void
	Stop ();

private:
	static RxIpduGroupType RxIpduGroups_[cfOS_COM_ASCOM_RX_IPDU_GROUP_MULTIPLICITY];
	static RxIpduGroupIdType RxIpduGroupMultiplicity_;
};

inline RxIpduGroupType &
RxIpduGroupType::Inst (RxIpduGroupIdType RxIpduGroupId) {
	return RxIpduGroups_[RxIpduGroupId];
}

inline void
RxIpduGroupType::InitAll (RxIpduGroupConfigType const * ConfigArray, RxIpduGroupIdType RxIpduGroupMultiplicity) {
	RxIpduGroupIdType i = 0;

	// We assume RxIpduGroupMultiplicity <= cfOS_COM_ASCOM_RX_IPDU_GROUP_MULTIPLICITY
	for (; i < RxIpduGroupMultiplicity; ++i) {
		RxIpduGroups_[i].Init (&ConfigArray[i]);
	}

	for (; i < cfOS_COM_ASCOM_RX_IPDU_GROUP_MULTIPLICITY; ++i) {
		// FIXME Uninit or stop or similar
	}
}

inline RxIpduGroupIdType
RxIpduGroupType::Id () const {
	return  this - RxIpduGroups_;
}

inline void
RxIpduGroupType::Init () {

}

inline void
RxIpduGroupType::Init (RxIpduGroupConfigType const * Config) {
	*(RxIpduGroupConfigType *)this = *Config;
	Init ();
}

}}}

#endif
