#ifndef OS_COM_ASCOM_RX_IPDU_TYPE_H
#define OS_COM_ASCOM_RX_IPDU_TYPE_H

#include "os/com/ComStack_Types.h"
#include "os/com/ascom/ConfigTypes.h"

namespace os { namespace com { namespace ascom {

struct RxIpduType : public RxIpduConfigType {
public:
	static RxIpduType&
	Inst (RxIpduIdType RxIpduId);

	static void
	InitAll (RxIpduConfigType const * ConfigArray, RxIpduIdType RxIpduMultiplicity);

	static RxIpduIdType
	Multiplicity ();

	RxIpduIdType
	Id () const;

	void
	Init (RxIpduConfigType const * ConfigPtr);

	void
	Init ();

	void
	Start (Bool Initialize);

	void
	Stop ();

	void
	RxIndication(UInt8 const * SduPtr);

private:
	static RxIpduType RxIpdus_[cfOS_COM_ASCOM_RX_IPDU_MULTIPLICITY];
	static RxIpduIdType RxIpduMultiplicity_;
};

inline RxIpduType&
RxIpduType::Inst (RxIpduIdType RxIpduId) {
	return RxIpdus_[RxIpduId];
}

inline RxIpduIdType
RxIpduType::Multiplicity () {
	return RxIpduMultiplicity_;
}

inline void
RxIpduType::InitAll (RxIpduConfigType const * ConfigArray, RxIpduIdType RxIpduMultiplicity) {
	RxIpduIdType i = 0;

	// We assume RxIpduMultiplicity <= cfOS_COM_ASCOM_RX_IPDU_MULTIPLICITY
	for(; i < RxIpduMultiplicity; ++i) {
		RxIpdus_[i].Init(&ConfigArray[i]);
	}

	RxIpduMultiplicity_ = i;

	for(; i < cfOS_COM_ASCOM_RX_IPDU_MULTIPLICITY; ++i) {
		// FIXME Uninit or stop or similar
	}
}

inline RxIpduIdType
RxIpduType::Id () const {
	return this - RxIpdus_;
}

inline void
RxIpduType::Init (RxIpduConfigType const * ConfigPtr) {
	*(RxIpduConfigType *)this = *ConfigPtr;
	Init();
}

}}}

#endif
