#ifndef OS_COM_TX_SIGNAL_GROUP_TYPE_H
#define OS_COM_TX_SIGNAL_GROUP_TYPE_H

#include "util/types.h"
#include "os/com/ComStack_Types.h"
#include "os/com/ascom/ConfigTypes.h"

namespace os { namespace com { namespace ascom {

class TxIpduType;
class TxSignalType;

class TxSignalGroupType : public TxSignalGroupConfigType {
public:
	static void
	InitAll(TxSignalGroupConfigType const * ConfigArray, TxSignalGroupIdType NumTxSignalGroups);

	static TxSignalGroupType &
	Inst(TxSignalGroupIdType SignalId);

	TxSignalGroupIdType
	Id() const;

	void
	Init(TxSignalGroupConfigType const * ConfigPtr);

	void
	Init();

	void
	Start (Bool Initialize);

	void
	Stop ();

	void
	TxConfirmation(UInt8 const * SduPtr);

	StatusType
	SendSignalGroup ();

private:
	static TxSignalGroupType TxSignalGroups_[cfOS_COM_ASCOM_RX_SIGNAL_GROUP_MULTIPLICITY];
};

inline void
TxSignalGroupType::InitAll(TxSignalGroupConfigType const * ConfigArray, TxSignalGroupIdType NumTxSignalGroups) {
	TxSignalGroupIdType i = 0;

	// We assume NumTxSignalGroups <= cfOS_COM_ASCOM_RX_SIGNAL_GROUP_MULTIPLICITY
	for(; i < NumTxSignalGroups; ++i) {
		TxSignalGroups_[i].Init(&ConfigArray[i]);
	}

	for(; i < cfOS_COM_ASCOM_RX_SIGNAL_GROUP_MULTIPLICITY; ++i) {
		// FIXME Uninit or stop or similar
	}
}

inline TxSignalGroupType &
TxSignalGroupType::Inst(TxSignalGroupIdType SignalGroupId) {
	return TxSignalGroups_[SignalGroupId];
}

inline TxSignalGroupIdType
TxSignalGroupType::Id() const {
	return this - TxSignalGroups_;
}

inline void
TxSignalGroupType::Init(TxSignalGroupConfigType const * ConfigPtr) {
	*(TxSignalGroupConfigType*)this = *ConfigPtr;
	Init();
}

inline void
TxSignalGroupType::Init() {
}

}}}

#endif
