#ifndef OS_DEV_STD_SERIAL0_H
#define OS_DEV_STD_SERIAL0_H

#include "hw/hal/Serial0.h"
#include "os/krn/Mutex.h"
#include "stdinc.h"


namespace os {
namespace dev {
namespace std {

	
class Serial0 : public hw::hal::Serial0 {
	static Serial0 theSerial0_;
	os::krn::Mutex writers;
	os::krn::Mutex readers;


	class VIRQ_REC : public IRQ_REC {
		static VIRQ_REC instance_;
		static Bool Handler() {return true;}
		
		static Bool Prologue() {
			disable();
			return true;
		}

		static void Epilogue() {
			Serial0::Inst().readers.v();
		}
	  public: //workaround
		static VIRQ_REC &Inst() {return instance_;}
		void init() { IRQ_REC::init(); }
	};

	class VIRQ_TBUF : public IRQ_TBUF {
		static VIRQ_TBUF instance_;
		static Bool Handler() {return true;}
		
		static Bool Prologue() {
			disable();
			return true;
		}

		static void Epilogue() {
			Serial0::Inst().writers.v();
		}
	  public: //workaround
		static VIRQ_TBUF &Inst() {return instance_;	}
		void init() { IRQ_REC::init(); }		
	};
	
protected:
	Serial0() {}

	void lock() {};

	void unlock() {};

public:
	static Serial0& Inst() {
		return theSerial0_; 
	}

	typedef hw::hal::Serial0 Super;

	void putc_( UInt8 ch );

	UInt8 getc_();

private:
	void init();
};


}}}	// namespace os::dev::std

/*#ifdef cfOS_INLINE
	#include "Serial0.inl"
#endif*/


#endif // OS_DEV_STD_SERIAL0_H
