// $Id: ISR.h 1336 2011-01-21 15:31:03Z chb $
// Created: 2007-07-12 siwahofe

#ifndef __OS_KRN_ISR_H__
#define __OS_KRN_ISR_H__

#include "ciaoConfig.h"
#include "util/types.h"
#include "hw/hal/platform.h" //#include "hw/dev/IRQCtrl.h"

namespace os { namespace krn {

struct ISR {

	// data type to represent number of ISRs (category 2) plus INVALID
	typedef uint_t_value <(cfOS_NUMBER_OF_CATEGORY_2_ISRS + 1)>::T Id;
	static const Id INVALID = cfOS_NUMBER_OF_CATEGORY_2_ISRS;

 	typedef void (* Function) ();
	typedef ::hw::hal::ServiceRequestRegisterType Register; //typedef SRC_t_nonv *Register;

	Function function_;

	//function pointer to hw::dev::IRQCtrl::reg()
	Register reg;

	static ISR& Inst (Id isrid);

	static Function getFunction (Id isrid) {
		return Inst (isrid).function_;
	}

	static void disableISR (Id isrid) {
		hw::hal::disableISR(Inst(isrid).reg); //Inst(isrid).reg->bits.SRE = 0;
	}

	static void enableISR (Id isrid) {
		hw::hal::enableISR(Inst(isrid).reg); //Inst(isrid).reg->bits.SRE = 1;
	}
};


extern ISR theISRs [];

inline ISR& ISR::Inst (ISR::Id isrid) {
	return theISRs [isrid];
}

}} // namespace os::krn

#endif // __OS_KRN_ISR_H__
