// $Id: Sched.h 995 2009-08-11 14:26:31Z mike $
// Created:   27.06.2006 lohmann

#ifndef __OS_SCHED_H__
#define __OS_SCHED_H__

#include "SchedImpl.h"

namespace os { namespace krn {

// class Sched is the user-interface to the scheduler which is
// replicated into the ciao-Layer

class Sched : private SchedImpl {
  public:
    typedef SchedImpl Super;
  
  protected:
    static Sched theSched_;
    Sched(){}
    void init(){
//    	Super::init();
    }
    
  public:
 	typedef Super::Id Id;
 
    static Sched& Inst() {
    	return theSched_;
    }
    
	// whom: terminated -> ready
	void activate( Id whom ) {
		Super::activate( whom );
	}
	
	// me: running -> waiting
	void block() {
		Super::block( Super::getRunning() );
	}
	
	// whom: waiting -> ready
	void awake( Id whom ) {
		Super::awake( whom );
	}
	
	// me: running -> terminated
	void exit() {
		Super::exit( getRunning() );
	}
	
	// voluntarily give CPU to next task with same priority
	void reschedule() {
		Super::reschedule();
	}
	
	// get own task id
	Id getRunning() const {
		return Super::getRunning();
	}
};

}} // namespace os::krn


 
#endif // __OS_SCHED_H__
