#ifndef OS_MP_RAWCONTEXTACCESS_H_
#define OS_MP_RAWCONTEXTACCESS_H_

#include "hw/hal/TCBUser.h"
#include "os/krn/SchedImpl.h"
#include "os/krn/Task.h"
#include "util/types.h"

namespace os { namespace mp {

class ContextAccess_Task
{
	
public:
	static Ptr getInitialStackUpper() {
		return task().stack_;
	}

	static os::krn::ApplicationType getInitialApplication() {
		return os::krn::Task::getApplication( tid_() );
	}

protected:
	static os::krn::Task::Id tid_() {
		return 	os::krn::SchedImpl::Inst().getActiveContext();
	}
	static os::krn::Task &task() {
		return os::krn::Task::Inst( tid_() );
	}

private:
	ContextAccess_Task() {
		// should not be instantiated
	}
};

}} //os::mp

#endif /*RAWCONTEXTACCESS_H_*/
