#ifndef __FixedFit_h__
#define __FixedFit_h__

#include "util/types.h"
#include "mem/MemPool.h"
#include "util/container/List.h"

template<int BS>
class FixedFit{

public:
	typedef UInt8 length_t;
	typedef Chain<length_t> MemBlock;
	
	enum{_blocksize=BS};
	
private:
	 
	List<length_t> _mem_blocks;
	//UIntPtr _size;
	//UIntPtr blocksize;

public:
	
	FixedFit(MemPoolBase& mempool){//:_size(0){
		UInt8* cur_addr = static_cast<UInt8*>(mempool.addr());
		UInt8* end_addr = static_cast<UInt8*>(mempool.addr()) + mempool.size();
		_mem_blocks.push_front((MemBlock*)(cur_addr));
		while(cur_addr+(2*_blocksize) <= end_addr ){
			((MemBlock*)cur_addr)->setNext((MemBlock*)(cur_addr+_blocksize));
		    cur_addr = cur_addr+_blocksize;
		    //++_size;
		}
	}
	
	~FixedFit(){}
	const Ptr get2(UIntPtr& size){
		return static_cast<Ptr>(_mem_blocks.pop_front());
	};
	
	
	const Ptr get(UIntPtr size){
		return static_cast<Ptr>(_mem_blocks.pop_front());
	}
		
	void put(Ptr addr){
		_mem_blocks.push_front(static_cast<MemBlock*>(addr));
	}
	
};

#endif //__FixedFit_h__
