// Testcase InterruptPCP appcode.cpp 
// sirupfis 14.02.2008

#include "appcode.h"
#include "as/AS.h"
#include "objects.h"
#include "stdio.h"

#include "hw/irq/PCP.h"
#include "hw/irq/DMA_SYSSRC2.h"
#include "hw/hal/STMTimer.h"

// Register definitions - TODO: move to some header file ...
#define IGCR0	*((unsigned int volatile *) 0xF0000094)	/* Interrupt Gating Register 0 */
#define EICR0	*((unsigned int volatile *) 0xF0000080)	/* External Input Channel Register 0 */

//HAS to be overridden! (standard-main() only does StartOS)

int CIAO_WEAK main () {

	// configure ECU to generate interrupt on DMA_SYSSRC2 after
	// reciving singal on P1.0 and to generate interrupt on
	// DMA_SYSSRC3 after reciving singal on P1.1
	IGCR0 = 0xa002a001;
	EICR0 = 0x1a000a00;

	hw::irq::PCP::setTaskInt((os::krn::Task::Pri) 5, (os::krn::Task::Pri) 5, os::krn::Task::Inst(Task2), Task2);
	hw::irq::DMA_SYSSRC2::setTOSPCP ();
	// enable SRN DMA_SYSSRC2
	hw::irq::DMA_SYSSRC2::enable ();
	
	unsigned usec = 50 * 1000;
	hw::irq::PCP::setTaskInt((os::krn::Task::Pri) 7, (os::krn::Task::Pri) 7, os::krn::Task::Inst(Task3), Task3);
	hw::hal::STMTimer0::Inst().windupPeriodical( hw::hal::STMTimer0::usec2units( usec ) );
	hw::hal::STMTimer0::IRQ::setTOSPCP ();
	hw::hal::STMTimer0::Inst().start();
	hw::hal::STMTimer0::IRQ::enable();
	// enable interrupts for cpu
	hw::hal::CPU::enable();
	
	// start OS
	os::krn::OSControl::Inst ().startOS (OSDEFAULTAPPMODE);
	return 0;
}


void Alpha::functionTaskTask0 (void) {
//TASKDEF (Alpha,Task0) {
	while (true)
	{
		asm ( " " );
		for (int i = 0; i < 80000; i++)
		{
			asm ( "nop" );
		}
		asm ( " " );
		
		//triggerTask2();
		
		asm ( " " );
		for (int i = 0; i < 80000; i++)
		{
			asm ( "nop" );
		}
		asm ( " " );

		// suspend task
		//AS::ActivateTask (Task1);
   	//os::krn::SchedImpl::Inst ().block (Task0);
		AS::TerminateTask();
   }
}

void Alpha::functionTaskTask1 (void) {
	UInt32 ticks = hw::hal::STMTimer0::usec2units( 1000 );
	int count;

		count = 0;
		UInt32 next =	hw::dev::STM::TIM<0>() + ticks;
	
		while (count < 20)
		{
			if ((hw::dev::STM::TIM<0>() < (next - ticks)) || (hw::dev::STM::TIM<0>() > (next + ticks)))
			{
				next = hw::dev::STM::TIM<0>() + ticks;
				count++;
			}
			else if (hw::dev::STM::TIM<0>() > next)
			{
				next = next + ticks;
				count++;
			}
		}
		AS::TerminateTask();
}

void Alpha::functionTaskTask3 (void) {
//TASKDEF (Alpha,Task3) {

	UInt32 ticks = hw::hal::STMTimer0::usec2units( 1000 );
	int count;

		hw::hal::STMTimer0::Inst().irqAck();
		hw::hal::CPU::enable();

		count = 0;
		UInt32 next =	hw::dev::STM::TIM<0>() + ticks;
	
		while (count < 20)
		{
			if ((hw::dev::STM::TIM<0>() < (next - ticks)) || (hw::dev::STM::TIM<0>() > (next + ticks)))
			{
				next = hw::dev::STM::TIM<0>() + ticks;
				count++;
			}
			else if (hw::dev::STM::TIM<0>() > next)
			{
				next = next + ticks;
				count++;
			}
		}

		// suspend task
   	//os::krn::SchedImpl::Inst ().exitRunning ();
   	//AS::ActivateTask(Task1);
		AS::TerminateTask();
}

void Alpha::functionTaskTask2 (void) {
//TASKDEF (Alpha,Task2) {
	UInt32 ticks = hw::hal::STMTimer0::usec2units( 1000 );
	int count;

//	while (true)
//	{
//		hw::hal::CPU::enable();
		
		count = 0;
		UInt32 next =	hw::dev::STM::TIM<0>() + ticks;
	
		while (count < 5)
		{
			if ((hw::dev::STM::TIM<0>() < (next - ticks)) || (hw::dev::STM::TIM<0>() > (next + ticks)))
			{
				next = hw::dev::STM::TIM<0>() + ticks;
				count++;
			}
			else if (hw::dev::STM::TIM<0>() > next)
			{
				next = next + ticks;
				count++;
			}
		}

		// suspend task
   	//os::krn::SchedImpl::Inst ().exitRunning ();
		AS::TerminateTask();

//   }
}
