// Testcase InterruptSemaphore appcode.cpp 
// sirupfis 14.02.2008 

#include "appcode.h"
#include "as/AS.h"
#include "objects.h"
#include "stdio.h"

#include "hw/irq/DMA_SYSSRC2.h"
#include "hw/hal/STMTimer.h"


// Register definitions - TODO: move to some header file ...

#define IGCR0	*((unsigned int volatile *) 0xF0000094)	/* Interrupt Gating Register 0 */
#define EICR0	*((unsigned int volatile *) 0xF0000080)	/* External Input Channel Register 0 */

//const EventMaskType MyEvent = 1 << 0; // TODO: check if Events can be declared in an other way 

//HAS to be overridden! (standard-main() only does StartOS)

int CIAO_WEAK main () {

	// configure ECU to generate interrupt on DMA_SYSSRC2 after
	// reciving singal on P1.0 and to generate interrupt on
	// DMA_SYSSRC3 after reciving singal on P1.1
	IGCR0 = 0xa002a001;
	EICR0 = 0x1a000a00;

	// enable SRN DMA_SYSSRC2
	hw::irq::DMA_SYSSRC2::enable ();
	
	unsigned usec = 50 * 1000;
	hw::hal::STMTimer0::Inst().windupPeriodical( hw::hal::STMTimer0::usec2units( usec ) );
	hw::hal::STMTimer0::Inst().start();
	hw::hal::STMTimer0::IRQ::enable();

	// enable interrupts for cpu
	hw::hal::CPU::enable();
	
	// start OS
	os::krn::OSControl::Inst ().startOS (OSDEFAULTAPPMODE);
	return 0;
}

Bool hw::irq::DMA_SYSSRC2::HWHandler () {
	Alpha::functionISRISRIn2();
	return true;
}

void Alpha::functionISRISRIn2(void) {
//ISRDEF (Alpha, ISRIn2) {
	TaskType runningTask;
	AS::GetTaskID (runningTask);
	
	// trigger AST if priority of interrupt is higher then priority of running task
	// to reschedule

	//AS::ActivateTask (Task2); // activate Task1 for Eventhandling
	AS::SetEvent (Task2, MyEvent);

	//if ((runningTask == os::krn::Task::INVALID) ||
	//		(hw::irq::DMA_SYSSRC2::IRQL() > os::krn::Task::getPri(runningTask)))
	//{
		//hw::hal::AST0::Inst().trigger();
	//	os::krn::SchedImpl::Inst().setNeedReschedule();
	//}

//	return true;
}

Bool hw::hal::STMTimer0::IRQ::HWHandler() {
	Alpha::functionISRISRIn1();
	return true;
}

void Alpha::functionISRISRIn1 (void) {
//ISRDEF (Alpha, ISRIn1) {
//Bool hw::hal::STMTimer0::IRQ::HWHandler() {

	//hw::hal::STMTimer0::Inst().irqAck();

//	TaskType runningTask;
//	AS::GetTaskID (runningTask);
	
	// trigger AST if priority of interrupt is higher then priority of running task
	// to reschedule

	AS::ActivateTask (Task3); // activate Task1 for Eventhandling

//	if (hw::hal::STMTimer0::IRQ::IRQL() > os::krn::Task::getPri(runningTask))
//	{
		//hw::hal::AST0::Inst().trigger();
//		os::krn::SchedImpl::Inst().setNeedReschedule();
//	}

//	return true;
}

void Alpha::functionTaskTask0 (void) {
//TASKDEF (Alpha,Task0) {
	while (true)
	{
		asm ( " " );
		for (int i = 0; i < 80000; i++)
		{
			asm ( "nop" );
		}
		asm ( " " );
		
		//triggerTask2();
		
		asm ( " " );
		for (int i = 0; i < 80000; i++)
		{
			asm ( "nop" );
		}
		asm ( " " );

		// suspend task
		//AS::ActivateTask (Task1);
		AS::TerminateTask();
   }
}

void Alpha::functionTaskTask1 (void) {
//TASKDEF (Alpha,Task1) {
		asm ( " " );
		for (int i = 0; i < 40000; i++)
		{
			asm ( "nop" );
		}
		asm ( " " );

		//AS::ActivateTask (Task0);
		AS::TerminateTask();
}

void Alpha::functionTaskTask3 (void) {
//TASKDEF (Alpha,Task3) {

	UInt32 ticks = hw::hal::STMTimer0::usec2units( 1 );
	int count;

		hw::hal::STMTimer0::Inst().irqAck();
		//hw::hal::CPU::enable();

		count = 0;
		UInt32 next =	hw::dev::STM::TIM<0>() + ticks;
	
		while (count < 20000)
		{
			if ((hw::dev::STM::TIM<0>() < (next - ticks)) || (hw::dev::STM::TIM<0>() > (next + ticks)))
			{
				next = hw::dev::STM::TIM<0>() + ticks;
				count++;
			}
			else if (hw::dev::STM::TIM<0>() > next)
			{
				next = next + ticks;
				count++;
			}
		}

		// suspend task
   	//os::krn::SchedImpl::Inst ().exitRunning ();
   	AS::TerminateTask();
}

void Alpha::functionTaskTask2 (void) {
//TASKDEF (Alpha,Task2) {
	UInt32 ticks = hw::hal::STMTimer0::usec2units( 5 );
	int count;
	EventMaskType mask;

	while (true)
	{
  		AS::WaitEvent (MyEvent);
		AS::GetEvent (Task2, mask);
		AS::ClearEvent (mask);

	
		//hw::hal::CPU::enable();
		
		count = 0;
		UInt32 next =	hw::dev::STM::TIM<0>() + ticks;
	
		while (count < 200)
		{
			if ((hw::dev::STM::TIM<0>() < (next - ticks)) || (hw::dev::STM::TIM<0>() > (next + ticks)))
			{
				next = hw::dev::STM::TIM<0>() + ticks;
				count++;
			}
			else if (hw::dev::STM::TIM<0>() > next)
			{
				next = next + ticks;
				count++;
			}
		}
   }
}

