// Testcase InterruptSemaphore appcode.cpp 
// sirupfis 14.02.2008 

#include "appcode.h"
#include "as/AS.h"
#include "objects.h"
#include "stdio.h"

#include "hw/irq/DMA_SYSSRC2.h"
#include "hw/hal/STMTimer.h"


// Register definitions - TODO: move to some header file ...

#define IGCR0	*((unsigned int volatile *) 0xF0000094)	/* Interrupt Gating Register 0 */
#define EICR0	*((unsigned int volatile *) 0xF0000080)	/* External Input Channel Register 0 */

//const EventMaskType MyEvent = 1 << 0; // TODO: check if Events can be declared in an other way 

//HAS to be overridden! (standard-main() only does StartOS)

int CIAO_WEAK main () {

	// enable SRN DMA_SYSSRC2
	hw::irq::DMA_SYSSRC2::enable ();
	
	// enable interrupts for cpu
	hw::hal::CPU::enable();
	
	// start OS
	os::krn::OSControl::Inst ().startOS (OSDEFAULTAPPMODE);
	return 0;
}

Bool hw::irq::DMA_SYSSRC2::HWHandler () {
	Alpha::functionISRISRIn2();
	return true;
}

void Alpha::functionISRISRIn2(void) {

	AS::SetEvent (Task2, MyEvent);
}

// dummy ...
void Alpha::functionISRISRIn1 (void) {

}

void Alpha::functionTaskTask3 (void) {

	AS::TerminateTask();
}

void Alpha::functionTaskTask1 (void) {

	AS::TerminateTask();
}

void triggerDMA_SYSSRC2() {

	hw::irq::DMA_SYSSRC2::set();	
}

void Alpha::functionTaskTask0 (void) {

	UInt32 ticks = hw::hal::STMTimer0::usec2units( 1000 );
	int count;

	while (true) {
	
		count = 0;
		UInt32 next =	hw::dev::STM::TIM<0>() + ticks;
	
		while (count < 5)
		{
			if ((hw::dev::STM::TIM<0>() < (next - ticks)) || (hw::dev::STM::TIM<0>() > (next + ticks)))
			{
				next = hw::dev::STM::TIM<0>() + ticks;
				count++;
			}
			else if (hw::dev::STM::TIM<0>() > next)
			{
				next = next + ticks;
				count++;
			}
		}
		
	triggerDMA_SYSSRC2();

		count = 0;
		next =	hw::dev::STM::TIM<0>() + ticks;
	
		while (count < 15)
		{
			if ((hw::dev::STM::TIM<0>() < (next - ticks)) || (hw::dev::STM::TIM<0>() > (next + ticks)))
			{
				next = hw::dev::STM::TIM<0>() + ticks;
				count++;
			}
			else if (hw::dev::STM::TIM<0>() > next)
			{
				next = next + ticks;
				count++;
			}
		}
	}
}

void Alpha::functionTaskTask2 (void) {
	UInt32 ticks = hw::hal::STMTimer0::usec2units( 1000 );
	int count;
	EventMaskType mask;

	while (true)
	{
  		AS::WaitEvent (MyEvent);
		AS::GetEvent (Task2, mask);
		AS::ClearEvent (mask);
		
		count = 0;
		UInt32 next =	hw::dev::STM::TIM<0>() + ticks;
	
		while (count < 5)
		{
			if ((hw::dev::STM::TIM<0>() < (next - ticks)) || (hw::dev::STM::TIM<0>() > (next + ticks)))
			{
				next = hw::dev::STM::TIM<0>() + ticks;
				count++;
			}
			else if (hw::dev::STM::TIM<0>() > next)
			{
				next = next + ticks;
				count++;
			}
		}
   }
}

