#include "hw/hal/TCBBasic.h"

hw::hal::TCBBasic tcb1;
hw::hal::TCBBasic tcb2;

int start1 = 0;
int start2 = 0;
int dispatch_before1 = 0;
int dispatch_before2 = 0;
int dispatch_after1 = 0;
int dispatch_after2 = 0;

const int MAX_STACK = 256;

void* stack1[ MAX_STACK ];
void* stack2[ MAX_STACK ];

void thread1_subfunc( hw::hal::TCBBasic* ) __attribute__((noinline));

void thread1_subfunc( 
	hw::hal::TCBBasic* me
	) 
{
	me->chain( &tcb2 );
}

void cfHAL_THREADFUNC_ATTRIBUTES thread1( 
	hw::hal::TCBBasic* me
	) 
{
	start1++;
	for( int i = 0; i < 3; ++i ) {
		dispatch_before1++;
		me->dispatch( &tcb2 );
		dispatch_after1++;
	}
	thread1_subfunc( me );
}

void cfHAL_THREADFUNC_ATTRIBUTES thread2( 
	hw::hal::TCBBasic* me 
	) 
{
	start2++;
	while( true ) {
		dispatch_before2++;
		me->dispatch( &tcb1 );
		dispatch_after2++;
	}
}



int main() {
	tcb1.init( &stack1[ MAX_STACK ], thread1 );
	tcb2.init( &stack2[ MAX_STACK ], thread2 );
	
	tcb1.go();

	return 0;		
}
