#include "../cfInitializers.h"
#include "os/com/ComStack_Types.h"

#include "os/com/ascom/Cfg.h"
#include "os/com/ascom/Filter.h"
#include "os/com/ascom/ConfigTypes.h"

#include "AsCom_Cfg.h"

namespace os { namespace com { namespace ascom {

static RxSignalConfigType const RxSigConfigs [] = {
	OS_COM_ASCOM_RX_SIGNAL_CONFIG_INITIALIZER(0, UInt8[4], 0, 3, 0, 7, Always, 0, 0),
};

static RxIpduConfigType const RxIpduConfigs[] = {
	OS_COM_ASCOM_RX_IPDU_CONFIG_INITIALIZER(0, 1, 0, 0, 0, 4, NULL, 0)
};

static RxIpduGroupConfigType const RxIpduGroupConfigs [] = {
	OS_COM_ASCOM_RX_IPDU_GROUP_CONFIG_INITIALIZER(0, 0)
};

static TxSignalConfigType const TxSigConfigs [] = {
	OS_COM_ASCOM_TX_SIGNAL_CONFIG_INITIALIZER(0, UInt8[4], 0, 3, 0, 7, PENDING, Always, 0, 0),
};

static TxIpduConfigType const TxIpduConfigs[] = {
	OS_COM_ASCOM_TX_IPDU_CONFIG_INITIALIZER(0, 0, 1, 1, 0, 4, NULL, 0, 0, 0, false, NONE, 0, 0, NONE, 0, 0),
};

static TxIpduGroupConfigType const TxIpduGroupConfigs [] = {
	OS_COM_ASCOM_TX_IPDU_GROUP_CONFIG_INITIALIZER(0, 0)
};

extern ConfigType const DefaultConfig;
ConfigType const DefaultConfig = OS_COM_ASCOM_CONFIG_INITIALIZER(RxSigConfigs, 1, NULL, 0, RxIpduConfigs, 1, RxIpduGroupConfigs, 1, TxSigConfigs, 1, NULL, 0, TxIpduConfigs, 1, TxIpduGroupConfigs, 1);

}}}

