#include "../cfInitializers.h"
#include "os/com/ComStack_Types.h"

#include "os/com/ascom/Cfg.h"
#include "os/com/ascom/Filter.h"
#include "os/com/ascom/ConfigTypes.h"

#include "AsCom_Cfg.h"

namespace os { namespace com { namespace ascom {

static os::com::ascom::RxSignalConfigType const RxSigConfigs[] = {
	OS_COM_ASCOM_RX_SIGNAL_CONFIG_INITIALIZER(0, UInt8,  0, 0, 0, 7, Always, 0, 0),
	OS_COM_ASCOM_RX_SIGNAL_CONFIG_INITIALIZER(0, UInt16, 1, 2, 0, 7, Always, 0, 0),
	OS_COM_ASCOM_RX_SIGNAL_CONFIG_INITIALIZER(0, UInt32, 3, 6, 0, 7, Always, 0, 0),
	OS_COM_ASCOM_RX_SIGNAL_CONFIG_INITIALIZER(1, Int8,  0, 0, 0, 7, Always, 0, 0),
	OS_COM_ASCOM_RX_SIGNAL_CONFIG_INITIALIZER(1, Int16, 1, 2, 0, 7, Always, 0, 0),
	OS_COM_ASCOM_RX_SIGNAL_CONFIG_INITIALIZER(1, Int32, 3, 6, 0, 7, Always, 0, 0)
};

static os::com::ascom::RxIpduConfigType const RxIpduConfigs[] = {
	OS_COM_ASCOM_RX_IPDU_CONFIG_INITIALIZER(0, 0, 2, 1, 0, 7, NULL, 0),
	OS_COM_ASCOM_RX_IPDU_CONFIG_INITIALIZER(0, 3, 5, 1, 0, 7, NULL, 0)
};

static RxIpduGroupConfigType const RxIpduGroupConfigs [] = {
	OS_COM_ASCOM_RX_IPDU_GROUP_CONFIG_INITIALIZER(0, 1)
};

extern ConfigType const DefaultConfig;
ConfigType const DefaultConfig = OS_COM_ASCOM_CONFIG_INITIALIZER(RxSigConfigs, 6, NULL, 0, RxIpduConfigs, 2, RxIpduGroupConfigs, 1, NULL, 0, NULL, 0, NULL, 0, NULL, 0);

}}}
