#include "../cfInitializers.h"
#include "os/com/ComStack_Types.h"

#include "os/com/ascom/Cfg.h"
#include "os/com/ascom/Filter.h"
#include "os/com/ascom/ConfigTypes.h"

#include "AsCom_Cfg.h"

namespace os { namespace com { namespace ascom {

// Only signal 2 should lead to a ipdu transmission
static os::com::ascom::TxSignalConfigType const TxSigConfigs[] = {
	OS_COM_ASCOM_TX_SIGNAL_CONFIG_INITIALIZER(0, UInt8,  0, 0, 0, 7, PENDING, Always, 0, 0),
	OS_COM_ASCOM_TX_SIGNAL_CONFIG_INITIALIZER(0, UInt16, 1, 2, 0, 7, PENDING, Always, 0, 0),
	OS_COM_ASCOM_TX_SIGNAL_CONFIG_INITIALIZER(0, UInt32, 3, 6, 0, 7, TRIGGERED, Always, 0, 0)
};

static os::com::ascom::TxIpduConfigType const TxIpduConfigs[] = {
	OS_COM_ASCOM_TX_IPDU_CONFIG_INITIALIZER(0, 0, 2, 1, 0, 7, NULL, 0, 4, 2, false, DIRECT, 0, 0, DIRECT, 0, 0)
};

static TxIpduGroupConfigType const TxIpduGroupConfigs [] = {
	OS_COM_ASCOM_TX_IPDU_GROUP_CONFIG_INITIALIZER(0, 0)
};

extern ConfigType const DefaultConfig;
ConfigType const DefaultConfig = OS_COM_ASCOM_CONFIG_INITIALIZER(NULL, 0, NULL, 0, NULL, 0, NULL, 0, TxSigConfigs, 3, NULL, 0, TxIpduConfigs, 1, TxIpduGroupConfigs, 1);

}}}
