#include "appcode.h"
#include "as/AS.h"
#include "objects.h"
#include "stdio.h"

void Alpha::functionTaskTask0 () {
	TaskStateType state;

	printf ("Task0 starting...\r\n");
	printf ("Task0 activating Task1.\r\n");
	AS::ActivateTask (Task1);
	printf ("Task0 scheduling.\r\n");
	AS::Schedule ();
	printf ("Task0 regaining control.\r\n");
	AS::GetTaskState (Task1, state);
	printf ("Task0: state of Task1 %i.\r\n", state);
	printf ("Task0 setting event.\r\n");
	AS::SetEvent (Task1, MyEvent);
	printf ("Task0 scheduling.\r\n");
	AS::Schedule ();
	printf ("Task0 ending...\r\n");
	AS::TerminateTask ();
}

void Beta::functionTaskTask1 () {
	static Bool chain = true;
	TaskType taskid;
	TaskStateType state;
	EventMaskType mask;

	printf ("Task1 starting...\r\n");
	AS::GetTaskID (taskid);
	AS::GetTaskState (Task0, state);
	printf ("Task1: ID %i, state of Task0 %i.\r\n", taskid, state);

	if (chain) {
		chain = false;
		printf ("Task1 waiting for event.\r\n");
		AS::WaitEvent (MyEvent);
		printf ("Task1 is running again.\r\n");
		AS::GetEvent (taskid, mask);
		printf ("Task1's event mask: %i.\r\n", mask);
		printf ("Task1 clears the event.\r\n");
		AS::ClearEvent (mask);
		AS::GetEvent (taskid, mask);
		printf ("Task1's event mask: %i.\r\n", mask);
		printf ("Task1 chaining itself...\r\n");
		AS::ChainTask (Task1);
	} else {
		printf ("Task1 ending...\r\n");
		AS::TerminateTask ();
	}
}
