#include "appcode.h"
#include "as/AS.h"
#include "objects.h"
#include "stdio.h"

#define NOPS() \
	asm volatile("nop");\
	asm volatile("nop");\
	asm volatile("nop");\
	asm volatile("nop");\
	asm volatile("nop");\
	asm volatile("nop");\
	asm volatile("nop");\
	asm volatile("nop");\
	asm volatile("nop");\
	asm volatile("nop");\
	asm volatile("nop");\
	asm volatile("nop");\
	asm volatile("nop");\
	asm volatile("nop");\
	asm volatile("nop");\
	asm volatile("nop")
	

//fake alarm (uncomment if necessary)
//os::krn::Alarm os::krn::theAlarms[0];


/*******************************************************/
// Test 0: NOPS
/*******************************************************/

//void Alpha::functionTaskTask0()
//{
//	while (1) {
//		NOPS();
//		
//		asm volatile("FROM:");
//		
//		NOPS();
//		NOPS();
//		NOPS();
//		NOPS();
//		NOPS();
//		NOPS();
//		NOPS();
//		NOPS();
//		
//		// 8*16 = 128
//		asm volatile("TO:");
//		
//		NOPS();
//	}	
//	AS::TerminateTask(); 
//}
//
//void Beta::functionTaskTask1()
//{
//	AS::TerminateTask();
//}

/*******************************************************/
// Test 1: Voluntary task switch in a non-preemptive system
/*******************************************************/

//void Alpha::functionTaskTask0()
//{
//	AS::ActivateTask(Task1);
//	NOPS();
//	asm volatile("FROM:");
//	AS::Schedule();
//	AS::ChainTask(Task0); 
//}
//
//void Beta::functionTaskTask1()
//{
//	asm volatile("TO:");
//	NOPS();
//	AS::TerminateTask();
//}

/*******************************************************/
// Test 2: Forced task switch in a non-preemptive system
/*******************************************************/

//void Alpha::functionTaskTask0()
//{
//	AS::ActivateTask(Task1);
//
//	NOPS();	
//	asm volatile("FROM:");
//	AS::TerminateTask();
//}
//
//void Beta::functionTaskTask1()
//{
//	asm volatile("TO:");
//	NOPS();
//	
//	AS::ChainTask(Task0);
//}

/*******************************************************/
// Test 3: Preemptive task switch in a fully-preemptive system
/*******************************************************/

//void Alpha::functionTaskTask0()
//{
//	NOPS();
//	asm volatile("FROM:");
//	AS::ActivateTask(Task1);
//	AS::ChainTask(Task0);
//}
//
//void Beta::functionTaskTask1()
//{
//	asm volatile("TO:");
//	NOPS();
//	AS::TerminateTask();
//}

/*******************************************************/
// Test 4: System start-up in a preemptive/non-preemptive system (does not matter)
// FROM is in the generated (!) main.cpp file in config/ directly after main()
/*******************************************************/

//void Alpha::functionTaskTask0()
//{
//	asm volatile("TO:");
//	NOPS();
//	while(true) {
//		NOPS();
//	}
//	AS::TerminateTask();
//}
//
//void Beta::functionTaskTask1()
//{
//	AS::TerminateTask();
//}
//
//int main() {
//	NOPS();
//	asm volatile("FROM:");	
//	AS::StartOS (OSDEFAULTAPPMODE);
//	_debug();
//}

/*******************************************************/
// Test 5: GetResource nonpreemptive, nothing happens
/*******************************************************/

//void Alpha::functionTaskTask0()
//{
//	while(true) {
//		NOPS();
//		asm volatile("FROM:");
//		AS::GetResource(Res0);
//		asm volatile("TO:");
//		NOPS();
//		
//		AS::ReleaseResource(Res0);
//	}
//	AS::TerminateTask();
//}
//
//void Beta::functionTaskTask1()
//{
//	AS::TerminateTask();
//}

/*******************************************************/
// Test 6: ReleaseResource nonpreemptive, nothing happens
/*******************************************************/

//void Alpha::functionTaskTask0()
//{
//	while(true) {
//		AS::GetResource(Res0);
//		
//		NOPS();
//		asm volatile("FROM:");
//		AS::ReleaseResource(Res0);
//		asm volatile("TO:");
//		NOPS();
//	}
//	AS::TerminateTask();
//}
//
//void Beta::functionTaskTask1()
//{
//	AS::TerminateTask();
//}

/*******************************************************/
// Test 7: ReleaseResource+preempt
/*******************************************************/

//void Alpha::functionTaskTask0()
//{
//	while(true) {
//		AS::GetResource(Res0);
//		AS::ActivateTask(Task1);
//		
//		NOPS();
//		asm volatile("FROM:");
//		AS::ReleaseResource(Res0);
//	}
//	AS::TerminateTask();
//}
//
//void Beta::functionTaskTask1()
//{
//	asm volatile("TO:");
//	NOPS();
//	AS::TerminateTask();
//}

/*******************************************************/
// Test 8: ISR Latency
/*******************************************************/

//void Alpha::functionTaskTask0()
//{
//	while(true) {
//		NOPS();
//		//generate interrupt
//        asm volatile("movh.a %a4,63457");
//        asm volatile("lea %a2,[%a4]-16");    //-16:SRC3, -12:SRC2...
//        //enable
//        asm volatile("imask %e0,1,12,1");
//        asm volatile("ldmst [%a2]0,%e0");
//        //request
//        asm volatile("imask %e0,1,15,1");
//        asm volatile("FROM:");
//        asm volatile("ldmst [%a2]0,%e0");
//	}
//	AS::TerminateTask();
//}
//
//void Alpha::functionISRISR0() {
//    asm volatile("TO:");
//    NOPS();
//}
//
//void Beta::functionTaskTask1()
//{
//	AS::TerminateTask();
//}

/*******************************************************/
// Test 9: preemtive Task Activation from ISR
/*******************************************************/

//void Alpha::functionTaskTask0()
//{
//	//while(true) {
//		//generate interrupt
//        asm volatile("movh.a %a4,63457");
//        asm volatile("lea %a2,[%a4]-16");    //-16:SRC3, -12:SRC2...
//        //enable
//        asm volatile("imask %e0,1,12,1");
//        asm volatile("ldmst [%a2]0,%e0");
//        //request
//        asm volatile("imask %e0,1,15,1");
//        asm volatile("ldmst [%a2]0,%e0");
//	//}
//	AS::TerminateTask();
//}
//
//void Alpha::functionISRISR0() {
//		NOPS();
//  asm volatile("FROM:");
//    AS::ActivateTask(Task1);
//}
//
//void Beta::functionTaskTask1()
//{
//  asm volatile("TO:");
//  NOPS();
//    AS::ActivateTask(Task0);
//	AS::TerminateTask();
//}

/*******************************************************/
// Test 10: task switch caused by WaitEvent (preemptive system)
/*******************************************************/

//void Alpha::functionTaskTask0()
//{
//	while(true) {
//		AS::ActivateTask(Task1);
//
//		asm volatile("TO:");
//		NOPS();
//		AS::SetEvent(Task1, Ev0);		
//	}
//	AS::TerminateTask();
//}
//
//void Beta::functionTaskTask1()
//{
//	NOPS();
//	asm volatile("FROM:");
//	AS::WaitEvent(Ev0);	
//	AS::ClearEvent(Ev0);
//	AS::TerminateTask();
//}

/*******************************************************/
// Test 11: preemptive task switch caused by SetEvent
/*******************************************************/

//void Alpha::functionTaskTask0()
//{
//	while(true) {
//		AS::ActivateTask(Task1);
//
//		NOPS();
//		asm volatile("FROM:");
//		AS::SetEvent(Task1, Ev0);		
//	}
//	AS::TerminateTask();
//}
//
//void Beta::functionTaskTask1()
//{
//	AS::WaitEvent(Ev0);	
//
//	asm volatile("TO:");
//	NOPS();
//
//	AS::ClearEvent(Ev0);
//	AS::TerminateTask();
//}



/*******************************************************/
// Test 12:  T0 (act)-> T1 (wait)-> T0 (res,int)
// -> ISR0 (set) -> T0 (release) -> T1
/*******************************************************/

//void Alpha::functionTaskTask0()
//{
//	while (1) {
//	    NOPS();
//		asm volatile("FROM:");
//
//		AS::ActivateTask(Task1);
//		asm volatile("MARK2:");
//		AS::GetResource(Res0);
//
//		//generate interrupt
//        asm volatile("movh.a %a4,63457");
//        asm volatile("lea %a2,[%a4]-16");    //-16:SRC3, -12:SRC2...
//        //enable
//        asm volatile("imask %e0,1,12,1");
//        asm volatile("ldmst [%a2]0,%e0");
//        //request
//        asm volatile("imask %e0,1,15,1");
//		asm volatile("MARK3:");
//        asm volatile("ldmst [%a2]0,%e0");
//		  NOPS(); //hardware latency
//		  NOPS(); //hardware latency
//		  asm volatile("MARK4:");
//
//		  AS::ReleaseResource(Res0);
//
//    	  asm volatile("TO:");
//    	  NOPS();
//	}
//}
//
//void Beta::functionTaskTask1()
//{
//		asm volatile("MARK1:");
//	AS::WaitEvent(Ev0);
//		  asm volatile("MARK5:");
//	
//	AS::ClearEvent(Ev0);
//	AS::TerminateTask();
//}
//
//
//void Alpha::functionISRISR0() {
//	AS::SetEvent(Task1, Ev0);
//}

