#ifndef _OS_MAILBOX_H_
#define _OS_MAILBOX_H_

#include "stdint.h"

namespace os { namespace msg {

	typedef uint8_t msgId_t;
	
	struct message {
		msgId_t id;
		enum {
			MSGFREE = 0,
			MSGALLOCED = 1,
			MSGSENT = 2,
		} state;
	};
	
	struct senderData {
		struct message* verwalt;
		msgId_t msgCount;
		uint16_t msgSize;
		uint8_t *data;
		msgId_t nextMessageId;
	};
	
	struct receiverData {
		msgId_t readId;
	};
	
	class SenderPort {
		public:
			struct senderData* sender;
			struct receiverData* receiver;
			msgId_t getMsg();
			uint8_t* getMsgData(msgId_t id);
			void sendMsg(msgId_t id);
	};
	
	class ReceiverPort {
		public:
			struct senderData* sender;
			struct receiverData* receiver;
			msgId_t recvMsg();
			uint8_t* getMsgData(msgId_t id);
			void releaseMsg(msgId_t id);
	};

}}; // namespace os::msg

/* Sender:
struct message msgPool[10];
uint8_t buffer[10*MSGSIZE];
struct senderData sender = { msgPool, 10, MSGSIZE, buffer, 1 };

SenderPort sendPort = { &sender, &receiver };

Empfaenger:

struct receiverData receiver = { 0 };
ReceiverPort receiverPort = {&sender, &receiver};

*/ 
#endif
