#ifndef _MESSAGE_H_
#define _MESSAGE_H_

#include "if_ether.h"
#include "ip_icmp.h"
#include "ip.h"
#include "arp.h"
#include "udp.h"

/*!
 * \file message.h
 * \brief Ethernet-IP-UDP Message Spec
 */
namespace os { namespace net {

class Message {
	public:
		ETHERHDR eth;
		union {
			uint8_t payload[100];
			struct {
				IPHDR ip;
				union {
					struct {
						UDPHDR header;
						uint8_t data[100];
					} udp;
					struct {
						ICMPHDR header;
						uint8_t data[100];
					} icmp;
				};
			};
			ETHERARP arp;
		};
		uint16_t size;
};

}} // namespace os::net

#endif
