#include "appcode.h"
#include "hw/hal/In0.h"
#include "hw/hal/Timer1.h"
#include "hw/irq/DMA_SYSSRC2.h"
#include "hw/irq/DMA_SYSSRC3.h"
#include "hw/irq/STM.h"
#include "as/AS.h"
#include "objects.h"
#include "stdio.h"
#include "os/krn/ISR2Support_Slice2.ah"

void Alpha::functionTaskTask0 (void) {
	int i = 0;

	hw::irq::DMA_SYSSRC2::enable();
	hw::irq::DMA_SYSSRC3::enable();
	hw::irq::STM_SRC1::enable();

	printf("\r\nSTM frequency: %u\r\n", hw::hal::Timer1::Inst().freq());
	printf("1000 Units = %u usec. Maximum time interval: %u usec\r\n", hw::hal::Timer1::Inst().units2usec(1000), hw::hal::Timer1::Inst().usecMax());

	printf ("Task0 starting...\r\n");
	printf ("Task0 activating Task1.\r\n");
	AS::ActivateTask (Task1);
	printf ("Task0 scheduling.\r\n");
	AS::Schedule ();

	printf ("Task0 infinite loop \r\n");
	while (1 > 0){
		if ((++i % (1000000)) == 0){
			printf("x");
		}
	}
}

void Beta::functionTaskTask1 (void) {
	static Bool chain = true;
	TaskType taskid;
	TaskStateType state;

	printf ("Task1 starting...\r\n");
	AS::GetTaskID (taskid);
	AS::GetTaskState (Task0, state);
	printf ("Task1: ID %i, state of Task0 %i.\r\n", taskid, state);

	if (chain) {
		chain = false;
		printf ("Task1 chaining itself...\r\n");
		AS::ChainTask (Task1);
	} else {
		printf ("Task1 ending...\r\n");
		AS::TerminateTask ();
	}
}

void Alpha::functionISRButton0ISR (void) {
	//AS::ActivateTask (Task1);
	printf("Hello from Button 0\r\n");
}

void Alpha::functionISRButton1ISR (void) {
	//AS::ActivateTask (Task1);
	printf("Hello from Button 1\r\n");
}
