#include <tut.h>
#include "util/container/DlChain.h"

namespace tut
{
  // Data used by each test
  struct dlchain_basic
  { 
	typedef DlChain<int> CustomChain;
    CustomChain c1;
    CustomChain c2;
    CustomChain c3;
    dlchain_basic(): c1(1),c2(2),c3(3){}
  };

  // Test group registration
  typedef test_group<dlchain_basic> factory;
  typedef factory::object object;
}

namespace
{
  tut::factory tf("dlchain basic operations");
}

namespace tut
{
   /**
   * Checks if getNext and getPrev of return 0
   */
  template<>
  template<>
  void object::test<1>()
  {
    ensure("previous element of c1 is null",c1.getPrev() == 0);
    ensure("next element of c1 is null",c1.getNext() == 0);
  }
  
  /**
   * Check constructors and get operations
   */
  template<>
  template<>
  void object::test<2>()
  {
  	CustomChain cm(&c1,&c2,42);
  	ensure("next element of c1 is cm",c1.getNext() == &cm);
    ensure("previous element of cm is c1",cm.getPrev() == &c1);
    ensure("next element of cm is c2",cm.getNext() == &c2);
    ensure("previous element of c2 is cm",c2.getPrev() == &cm);
    
  }
  
  /**
   * Check findFirst and findLast
   */
  template<>
  template<>
  void object::test<3>()
  {
  	CustomChain cm(&c1,&c2,42);
  	c2.setNext(&c3);
  	ensure("first element  is c1",cm.findFirst() == &c1);
    ensure("last element is c3",cm.findLast() == &c3);
  }
  
  
  
}
