<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet 
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
  xmlns:cm="http://www.pure-systems.com/consul/model"
  version="1.0">

  <!-- generate text -->
  <xsl:output method="text"  encoding="iso-8859-1"/>
  <!-- override built-in template for text and attributes -->
  <!-- avoid untreated text to be copied through          -->
  <xsl:template match="text()|@*"/>

  <!-- hash all element ids -->
  <xsl:key name="element-by-id" match="cm:elements/cm:element" use="@cm:id"/>

  <!-- start conversation with the consulmodel -->
  <xsl:template match="//cm:consulmodels/cm:consulmodel[@cm:type='ps:cfm']">
    <xsl:for-each select="key('element-by-id',cm:elements/@cm:rootid)">
      <xsl:call-template name="convert-element"/>
    </xsl:for-each>
  </xsl:template>
  
  <!-- convert the current element -->
  <xsl:template name="convert-element">
    
    <!-- start conversation of the attributes -->
    <xsl:call-template name="convert-attributes"/>
    
    <!-- convert the child elements -->
    <xsl:for-each select="cm:relations[@cm:class='ps:children']/cm:relation/cm:target">
      <xsl:for-each select="key('element-by-id',substring-after(.,'/'))">
        <xsl:call-template name="convert-element"/>
      </xsl:for-each>
    </xsl:for-each>
    
  </xsl:template>


  <xsl:template name="convert-attributes">
    <xsl:for-each select="cm:properties/cm:property[starts-with(@cm:name,'IRQ')]">
      <xsl:if test="cm:constant=''">
        <xsl:text>IRQ_NOENTRY(</xsl:text>
        <xsl:value-of select="substring-after(@cm:name,'IRQ')"/>
      </xsl:if>
      <xsl:if test="cm:constant !=''">
        <xsl:text>IRQ_ENTRY(</xsl:text>
        <xsl:value-of select="substring-after(@cm:name,'IRQ')"/>
        <xsl:text>,</xsl:text>
        <xsl:value-of select="cm:constant"/>          
      </xsl:if>
      <xsl:text>)</xsl:text>
      <xsl:text>&#10;</xsl:text>
    </xsl:for-each>
   </xsl:template>
    
</xsl:stylesheet>
