<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet 
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
  version="1.0">

  <xsl:include href="../common.xsl" />

  <xsl:template match="ciaoApp">

	<xsl:text>//generated CiAO runtime
#ifndef APP_POINTCUTS_H_
#define APP_POINTCUTS_H_

#include "os/mp/common_pointcuts.h"
</xsl:text>

<xsl:for-each select="applicationheaders/applicationpointcuts">
	<xsl:text>#include "</xsl:text>
	<xsl:value-of select="@name"/>
	<xsl:text>"&#10;</xsl:text>
</xsl:for-each>
	<xsl:text>

namespace os { namespace mp {
</xsl:text>


	<xsl:for-each select="osapplication">
		<xsl:text>    pointcut pcApplication</xsl:text>
		<xsl:value-of select="@name"/>
		<xsl:text>() = ""&#10;        </xsl:text>
		<xsl:for-each select="componentref">
			<xsl:text> ||&#10;        </xsl:text>
			<xsl:text>"% </xsl:text>
			<xsl:call-template name="component_classname">
				<xsl:with-param name="name" select="@name"/>
			</xsl:call-template>
			<xsl:text>::...::%(...)"</xsl:text>
		</xsl:for-each>	
		<xsl:text> ;&#10;</xsl:text>
	</xsl:for-each>
	
<xsl:text>

    pointcut pcNonTrusted() = ""
        </xsl:text>
	<xsl:for-each select="osapplication[@trusted='false']">
		<xsl:text> ||&#10;        </xsl:text>
		<xsl:text>pcApplication</xsl:text>
		<xsl:value-of select="@name"/>
		<xsl:text>()</xsl:text>
	</xsl:for-each>
	<!-- just a quick and dirty hack; probably won't work when multiple
	     pointcut headers exist -->
	<xsl:for-each select="applicationheaders/applicationpointcuts">
		<xsl:text> ||&#10;        appNonTrusted()</xsl:text>
	</xsl:for-each>
	<xsl:text> ;</xsl:text>

<xsl:text>
    pointcut pcTrustedApps() = ""
        </xsl:text>
	<xsl:for-each select="osapplication[@trusted='true']">
		<xsl:text> ||&#10;        </xsl:text>
		<xsl:text>pcApplication</xsl:text>
		<xsl:value-of select="@name"/>
		<xsl:text>()</xsl:text>
	</xsl:for-each>
	<!-- just a quick and dirty hack; probably won't work when multiple
	     pointcut headers exist -->
	<xsl:for-each select="applicationheaders/applicationpointcuts">
		<xsl:text> ||&#10;        appTrusted()</xsl:text>
	</xsl:for-each>
	<xsl:text> ;</xsl:text>

<xsl:text>

</xsl:text>

	<xsl:for-each select="osapplication">
		<xsl:text>    pointcut pcToApplication</xsl:text>
		<xsl:value-of select="@name"/>
		<xsl:text>() = call(pcApplication</xsl:text>
		<xsl:value-of select="@name"/>
		<xsl:text>()) &amp;&amp; !within(pcApplication</xsl:text>
		<xsl:value-of select="@name"/>
		<xsl:text>());&#10;</xsl:text>
	</xsl:for-each>
	
<xsl:text>
    pointcut pcToN() = call("")
        </xsl:text>
	<xsl:for-each select="osapplication[@trusted='false']">
		<xsl:text> ||&#10;        </xsl:text>
		<xsl:text>pcToApplication</xsl:text>
		<xsl:value-of select="@name"/>
		<xsl:text>()</xsl:text>
	</xsl:for-each>
	<xsl:text> ;</xsl:text>

<xsl:text>
    pointcut pcToT() = call("")
        </xsl:text>
	<xsl:for-each select="osapplication[@trusted='true']">
		<xsl:text> ||&#10;        </xsl:text>
		<xsl:text>pcToApplication</xsl:text>
		<xsl:value-of select="@name"/>
		<xsl:text>()</xsl:text>
	</xsl:for-each>
	<xsl:text> ;</xsl:text>

<xsl:text>

}} //namespace os::mp

namespace os { namespace tp {

pointcut pcISR2FunctionsWithArrivalRate() = ""</xsl:text>
	<xsl:for-each select="isr[@timeframe]">
		<xsl:text>&#10;    || "% hw::irq::</xsl:text>
		<xsl:value-of select="@device"/>
		<xsl:text>::Handler(...)"</xsl:text>
	</xsl:for-each>
	<xsl:text>;</xsl:text>
<xsl:text>

pointcut pcISR2FunctionsWithExecutionTimeBudget () = ""</xsl:text>
	<xsl:for-each select="isr[@executionbudget]">
		<xsl:text>&#10;    || "% hw::irq::</xsl:text>
		<xsl:value-of select="@device"/>
		<xsl:text>::Handler(...)"</xsl:text>
	</xsl:for-each>
	<xsl:text>;</xsl:text>
<xsl:text>

pointcut pcISR2FunctionsWithISRLockingTimeBudget () = ""</xsl:text>
	<xsl:for-each select="isr[@isrlockbudget]">
		<xsl:text>&#10;    || "% hw::irq::</xsl:text>
		<xsl:value-of select="@device"/>
		<xsl:text>::Handler(...)"</xsl:text>
	</xsl:for-each>
	<xsl:text>;</xsl:text>
<xsl:text>

pointcut pcISR2FunctionsWithResourceLockingTimeBudget () = ""</xsl:text>
	<xsl:for-each select="isr[@resourcelockbudget]">
		<xsl:text>&#10;    || "% hw::irq::</xsl:text>
		<xsl:value-of select="@device"/>
		<xsl:text>::Handler(...)"</xsl:text>
	</xsl:for-each>
	<xsl:text>;</xsl:text>
<xsl:text>

pointcut pcTaskFunctionsWithISRLockingTimeBudget () = ""</xsl:text>
	<xsl:for-each select="task[@isrlockbudget]">
		<xsl:text>&#10;    || "% ...::</xsl:text>
		<xsl:value-of select="@function"/>
		<xsl:text>(...)"</xsl:text>
	</xsl:for-each>
	<xsl:text>;</xsl:text>
<xsl:text>

pointcut pcTaskFunctionsWithResourceLockingTimeBudget () = ""</xsl:text>
	<xsl:for-each select="task[@resourcelockbudget]">
		<xsl:text>&#10;    || "% ...::</xsl:text>
		<xsl:value-of select="@function"/>
		<xsl:text>(...)"</xsl:text>
	</xsl:for-each>
	<xsl:text>;</xsl:text>
<xsl:text>

}} // namespace os::tp

#endif /*APP_POINTCUTS_AH_*/
</xsl:text>

  </xsl:template>

</xsl:stylesheet>
