<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
version="1.0">
<xsl:import href="../ComStacksCommon.xsl"/>
<xsl:output method="text"/>
<xsl:strip-space elements="*" />

<xsl:template match="/ComStacks">
#ifndef HW_HAL_CANIF_CFG_H
#define HW_HAL_CANIF_CFG_H

#include &#34;node.h&#34;

<xsl:apply-templates />

#endif
</xsl:template>


<!-- Template for all Can Stuff of one node-->
<xsl:template match="/ComStacks/Node/CanIf">

#define cfHW_HAL_CANIF_NUM_USED_LPDUS  <xsl:value-of select="count(TxLpdu) + count(RxLpdu)"/>
#define cfHW_HAL_CANIF_NUM_USED_RX_LPDUS <xsl:value-of select="count(RxLpdu)"/>
#define cfHW_HAL_CANIF_NUM_USED_TX_LPDUS <xsl:value-of select="count(TxLpdu)"/>
#define cfHW_HAL_CANIF_NUM_USED_CONTROLLERS <xsl:value-of select="count(../Can/Module/Controller)"/>

#include &#34;hw/hal/can/ConfigType.h&#34;

<xsl:for-each select="RxLpdu">
<xsl:if test="count(@Name) = 1 and not(@Name = '')">
#define CANIF_RX_LPDU_<xsl:value-of select="@Name" /> ((os::com::PduIdType)<xsl:value-of select="@LPduId" />)</xsl:if>
</xsl:for-each>


<xsl:for-each select="TxLpdu">
<xsl:if test="count(@Name) = 1 and not(@Name = '')">
#define CANIF_TX_LPDU_<xsl:value-of select="@Name" /> ((os::com::PduIdType)<xsl:value-of select="@LPduId" />)</xsl:if>
</xsl:for-each>


namespace hw { namespace hal { namespace can {

extern ConfigType const DefaultConfig;

<!--
extern ControllerConfigType ControllerMap[];

<xsl:if test="count(TxLpdu) > 0">
extern TxLpduConfigType TxLpduMap[];
</xsl:if>

<xsl:if test="count(RxLpdu) > 0">

<xsl:for-each select="../Can/Module[count(RxHwObject) > 0]">
namespace <xsl:value-of select="@Name"/> {

extern CanDriverConfigType const CanDriverConfig;
extern RxLpduConfigType const * const HrhMap[];

extern ConfigType DefaultConfig;

}; // namespace <xsl:value-of select="@Name"/>

</xsl:for-each>
</xsl:if>

-->
}}}
</xsl:template>

</xsl:stylesheet>

